//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//=======================================================================
//@V@:Note: This file generated by vgen V1.07 (00:31:08 21 Nov 1999).
//	SCcmdw.cpp:	Source for SCCmdWindow class
//=======================================================================

#include <v/vnotice.h>	// for vNoticeDialog
#include <v/vkeys.h>	// to map keys

#include <time.h>

#include "SCcmdw.h"	// our header

//	Start defines for the main window with 100

//@V@:BeginIDs
    enum {
	m_FirstCmd = 100, // Dummy Command
	VF_Message,			//put this here to force 101
	m_TestDialog,	// TestDialog menu
	m_Dialog,	// TestDialog menu
	m_ModalDialog,	// TestDialog menu
	b_Plot,	// Tool Bar test
	t_StatMessage,	// Status Bar test
	t_StatPosition,
	t_StatTest,
	cmdAuxTimer,	// AuxTimer
	m_Test,


	m_HelpMenu,
	m_Help1,
	m_Help2,
	m_Help3,
	m_Help4,

	m_ShowStatus,
	m_ShowInfoBox,
	m_MousePosRD,
	m_MousePosAA,
	m_OptionMenu,

	m_SaveSet,
	m_OpenSet,
	m_Print,
	m_About,

	m_NavMenu,
	m_CatMenu,
	m_ViewMenu,
	m_TimeMenu,
	m_ObjectsMenu,

	m_ColorMenu,
	m_Color,
	m_ColorNorm,
	m_ColorBonW,
	m_ColorWonB,
	m_ColorRonB,

	m_SetTimeLapse,
	m_StopTimeLapse,

	m_MagMenu,

	m_TargetMenu,
	m_Telrad,
	m_5DegDia,
	m_7DegDia,
	m_10DegDia,


	m_StyleMenu,
	m_AutoBlob,
	m_DotStyle,
	m_TickStyle,

	pbrH,

	m_LocMenu,

	m_SetTime,
	m_Now,
	m_UHour,
	m_DHour,
	m_UDay,
	m_DDay,
	m_UMin,
	m_DMin,
	m_UTen,
	m_DTen,

	//m_TimeZone,

	m_Mag3,
	m_Mag4,
	m_Mag5,
	m_Mag6,
	m_Mag7,
	m_Mag8,
	m_Mag9,
	m_Mag10,
	m_Mag11,
	m_Mag12,
	m_Mag13,


	m_GeoView,
	m_SkyView,
	m_SetLocation,
	m_RADecGrid,
	m_AltAzGrid,
	m_ViewCen,
	m_ConLines,
	m_ConNames,
	m_StarNames,
	m_Legend,
	m_PlanetMode,
	m_PlanetLabel,

	m_UtilMenu,
	m_ShowRecord,
	m_ShowRawRecord,
	m_LoadBSCat,
	m_LoadHipCat,
	m_LoadTycCat,
	m_PlanetPositions,

	m_BuildBS,
	m_BuildHip,
	m_BuildTyc,


	m_RePlot,
	m_ZoomIn,
	m_ZoomOut,
	m_Zoom90,
	m_Zoom45,

	m_GotoMenu,
	m_GotoSun,
	m_GotoMercury,
	m_GotoVenus,
	m_GotoMoon,
	m_GotoMars,
	m_GotoSaturn,
	m_GotoJupiter,
	m_GotoUranus,
	m_GotoNeptune,
	m_GotoPluto,

	m_LockMenu,
	m_UnLock,
	m_LockSun,
	m_LockMoon,

	m_eqDate,
	m_eqJ2000,
	m_geocentric,
	m_topocentric,
	m_Extra,

	l_L1,
	l_LTimeZone,
	t_RAh,
	t_RAm,
	t_Dec,
	t_VAng,
	t_Rot,
	t_Alt,
	t_Az,
	t_GMT,
	t_GMTS,
	t_Date,
	t_VAngAA,
	t_Julian,
	t_LZT,
	blkLast		// Last item
      };
//@V@:EndIDs


//@V@:BeginPulldownMenu FileMenu
    static vMenu FileMenu[] =
      {
	{"&Save Settings", m_SaveSet, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&Open Settings", m_OpenSet, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"&Save", M_Save, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"Save &as...", M_SaveAs, isSens, notChk, noKeyLbl, noKey, noSub},	
	//{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Print", m_Print, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"E&xit", M_Exit, isSens, notChk, noKeyLbl, noKey, noSub},
	{NULL}
      };
//@V@:EndPulldownMenu

//@V@:BeginPulldownMenu EditMenu
    //static vMenu EditMenu[] =
    //  {
	//{"Cut  ", M_Cut, isSens, notChk, "Ctrl-X", 'X'-'@', noSub},
	//{"Copy ", M_Copy, isSens, notChk, "Ctrl-C", 'C'-'@', noSub},
	//{"Paste", M_Paste, isSens, notChk, "Ctrl-V", 'V'-'@', noSub},
	//{NULL}
    //  };
//@V@:EndPulldownMenu

	static vMenu GotoMenu[] =
{
	{"Moon", m_GotoMoon, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Sun", m_GotoSun, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Mercury", m_GotoMercury, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Venus", m_GotoVenus, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Mars", m_GotoMars, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Jupiter", m_GotoJupiter, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Saturn", m_GotoSaturn, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Uranus", m_GotoUranus, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Neptune", m_GotoNeptune, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Pluto", m_GotoPluto, isSens, notChk, noKeyLbl, noKey, noSub},
	{NULL}
};

	static vMenu NavMenu[] =
      {
	{"&Plot", m_RePlot, isSens, notChk, "Ctrl-P", 'P'-'@', noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},	
	{"Zoom&In", m_ZoomIn, isSens, notChk, "Ctrl-I", 'I'-'@', noSub},
	{"Zoom&Out", m_ZoomOut, isSens, notChk, "Ctrl-O", 'O'-'@', noSub},
	{"Zoom&90", m_Zoom90, isSens, notChk, "Ctrl-Y", 'Y'-'@', noSub},
	{"Zoom&45", m_Zoom45, isSens, notChk, "Ctrl-U", 'U'-'@', noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Goto", m_GotoMenu, isSens, notUsed, notUsed, noKey, &GotoMenu[0]},
	{NULL}
      };


	static vMenu MagMenu[] =
      {
	{"3", m_Mag3, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&4", m_Mag4, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&5", m_Mag5, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&6", m_Mag6, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&7", m_Mag7, isSens, isChk, noKeyLbl, noKey, noSub},
	{"&8", m_Mag8, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&9", m_Mag9, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&10", m_Mag10, isSens, notChk, noKeyLbl, noKey, noSub},
	{"1&1", m_Mag11, isSens, notChk, noKeyLbl, noKey, noSub},
	{"1&2", m_Mag12, isSens, notChk, noKeyLbl, noKey, noSub},
	{"1&3", m_Mag13, isSens, notChk, noKeyLbl, noKey, noSub},
	
	{NULL}
      };

	static vMenu StyleMenu[] =
      {
	{"&Dots", m_DotStyle, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&Ticks", m_TickStyle, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},	
	{"Blobs", m_AutoBlob, isSens, isChk, noKeyLbl, noKey, noSub},	
	//{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	
	{NULL}
      };

	static vMenu TargetMenu[] =
      {
	{"5 Deg Dia", m_5DegDia, isSens, notChk, noKeyLbl, noKey, noSub},
	{"7 Deg Dia", m_7DegDia, isSens, notChk, noKeyLbl, noKey, noSub},
	{"10 Deg Dia", m_10DegDia, isSens, isChk, noKeyLbl, noKey, noSub},	
	{"Target", m_Telrad, isSens, notChk, noKeyLbl, noKey, noSub},		
	{NULL}
      };

static vMenu ColorMenu[] =
{
	{"Normal", m_ColorNorm, isSens, isChk, notUsed, noKey, noSub},
	{"Black on White", m_ColorBonW, isSens, notChk, notUsed, noKey, noSub},	
	{"White on Black", m_ColorWonB, isSens, notChk, noKeyLbl, noKey, noSub},		
	{"Red on Black", m_ColorRonB, isSens, notChk, noKeyLbl, noKey, noSub},		
	
	{NULL}
};

static vMenu ViewMenu[] =
{	
	{"&GeoView", m_GeoView, isSens, isChk, noKeyLbl, noKey, noSub},
	{"&SkyView", m_SkyView, isSens, notChk, noKeyLbl, noKey, noSub},	
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"&RADecGrid", m_RADecGrid, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&AltAzGrid", m_AltAzGrid, isSens, isChk, noKeyLbl, noKey, noSub},
	{"&Legend", m_Legend, isSens, notChk, noKeyLbl, noKey, noSub},
	{"&ConLines", m_ConLines, isSens, isChk, noKeyLbl, noKey, noSub},		
	{"Con&Names", m_ConNames, isSens, notChk, noKeyLbl, noKey, noSub},
	{"S&tarNames", m_StarNames, isSens, notChk, noKeyLbl, noKey, noSub},
	{"PlanetLabels",m_PlanetLabel, isSens, isChk, noKeyLbl, noKey, noSub},
	{"S&howTarget", m_ViewCen, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Tar&getStyle", m_TargetMenu, isSens, notUsed, notUsed, noKey, &TargetMenu[0]},
	{"Color", m_Color, isSens, notUsed, notUsed, noKey, &ColorMenu[0]},	
	{NULL}
};



static vMenu ObjectsMenu[] =
{
	{"S&tarStyle", m_StyleMenu, isSens, notUsed, notUsed, noKey, &StyleMenu[0]},
	{"&MagLimit", m_MagMenu, isSens, notUsed, notUsed, noKey, &MagMenu[0]},	
	{"&Planets", m_PlanetMode, isSens, isChk, noKeyLbl, noKey, noSub},
	//{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	//{"Goto", m_GotoMenu, isSens, notUsed, notUsed, noKey, &GotoMenu[0]},
	{NULL}
};

static vMenu LockMenu[] =
{
	{"Moon", m_LockMoon, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Sun", m_LockSun, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"Venus", m_LockVenus, isSens, notChk, noKeyLbl, noKey, noSub},	
	{NULL}
};



static vMenu TimeMenu[] =
{
	{"SetTime...", m_SetTime, isSens, notChk, notUsed, noKey, noSub},
	{"&Now", m_Now, isSens, notChk, "Ctrl-N", 'N'-'@', noSub},	
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"+Min", m_UMin, isSens, notChk, "Ctrl-M", 'M'-'@', noSub,0},
	{"-Min", m_DMin, isSens, notChk, "Ctrl-Shft-M", 'M'-'@', noSub,1},	
	{"+TenMin", m_UTen, isSens, notChk, "Ctrl-T", 'T'-'@', noSub,0},
	{"-TenMin", m_DTen, isSens, notChk, "Ctrl-Shft-T", 'T'-'@', noSub,1},	
	{"+Hour", m_UHour, isSens, notChk, "Ctrl-H", 'H'-'@', noSub,0},	
	{"-Hour", m_DHour, isSens, notChk, "Ctrl-Shft-H", 'H'-'@', noSub,1},	
	{"+Day", m_UDay, isSens, notChk, "Ctrl-D", 'D'-'@', noSub,0},
	{"-Day", m_DDay, isSens, notChk, "Ctrl-Shft-D", 'D'-'@', noSub,1},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Time Lapse...", m_SetTimeLapse, isSens, notChk, noKeyLbl, noKey, noSub},		
	{"Stop Time Lapse", m_StopTimeLapse, isSens, notChk, "Ctrl-S", 'S'-'@', noSub},		
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Lock View on Object", m_LockMenu, isSens, notUsed, notUsed, noKey, &LockMenu[0]},
	{"UnLock", m_UnLock, isSens, notChk, noKeyLbl, noKey, noSub,0},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	//{"TimeZone", m_TimeZone, isSens, notUsed, notUsed, noKey, &TimeZoneMenu[0]},
	//{"Daylight Savings Time",m_DaylightTime, isSens, notChk, noKeyLbl, noKey, noSub},
	{NULL}
};


static vMenu LocMenu[] =
{
	{"Set&Location...", m_SetLocation, isSens, 
		notChk, noKeyLbl, noKey, noSub},
	{NULL}
};


static vMenu OptionMenu[] =
{
	{"Show &Info Box", m_ShowInfoBox, isSens, notChk, "Ctrl-B", 'B'-'@', noSub},
	//{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"&Hide Status Bar", m_ShowStatus, isSens, 
	notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Position:RA Dec", m_MousePosRD, isSens, isChk, noKeyLbl, noKey, noSub},
	{"Position:Alt Az", m_MousePosAA, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Equinox of Date", m_eqDate, isSens, 
		notChk, noKeyLbl, noKey, noSub},
	{"Equinox J2000", m_eqJ2000, isSens, 
		isChk, noKeyLbl, noKey, noSub},

	{"Geocentric", m_geocentric, isSens, 
		notChk, noKeyLbl, noKey, noSub},
	{"Topocentric", m_topocentric, isSens, 
		isChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"Extra", m_Extra, isSens, 
		notChk, noKeyLbl, noKey, noSub},
	//{"&Test", m_Test, isSens, notChk, noKeyLbl, noKey, noSub},	
	{NULL}
};


static vMenu UtilMenu[] =
{
	{"Build bs_Cond_cond.dat", m_BuildBS, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Build hip_Cond_cond.dat", m_BuildHip, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Build tyc_Cond_cond.dat", m_BuildTyc, isSens, notChk, noKeyLbl, noKey, noSub},	
	{NULL}
};

static vMenu HelpMenu[] =
{
	{"Getting Started...", m_Help1, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Catalogs...", m_Help2, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"&About...", m_About, isSens, notChk, noKeyLbl, noKey, noSub},	
	{NULL}
};




	static vMenu CatMenu[] =
      {
	{"Load &BSCat", m_LoadBSCat, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Load &Hip Cat", m_LoadHipCat, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Load &Tyc Cat", m_LoadTycCat, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"GetRawRecord", m_GetRawRecord, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"&ShowRecord", m_ShowRecord, isSens, notChk, noKeyLbl, noKey, noSub},
	{"Show&RawRecord", m_ShowRawRecord, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},

	{"Planet Info...", m_PlanetPositions, isSens, notChk, noKeyLbl, noKey, noSub},
	{"-", M_Line, notSens, notChk, noKeyLbl, noKey, noSub},
	{"&Util", m_UtilMenu, isSens, notUsed, notUsed, noKey, &UtilMenu[0]},


	{NULL}
      };

//@V@:BeginPulldownMenu TestDialog
    //static vMenu TestDialog[] =
    //  {
	//{"Dialog", m_Dialog, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"Modal Dialog", m_ModalDialog, isSens, notChk, noKeyLbl, noKey, noSub},
	//{"Test", m_Test, isSens, notChk, noKeyLbl, noKey, noSub},
    //    {NULL}
     // };
//@V@:EndPulldownMenu

//@V@:BeginMenu StandardMenu
    static vMenu StandardMenu[] =
      {
	{"&File", M_File, isSens, notUsed, notUsed, noKey, &FileMenu[0]},
	{"&View", m_ViewMenu, isSens, notUsed, notUsed, noKey, &ViewMenu[0]},
	{"&Objects", m_ObjectsMenu, isSens, notUsed, notUsed, noKey, &ObjectsMenu[0]},
	{"&Nav", m_NavMenu, isSens, notUsed, notUsed, noKey, &NavMenu[0]},
	{"&Time", m_TimeMenu, isSens, notUsed, notUsed, noKey, &TimeMenu[0]},
	{"&Loc", m_LocMenu, isSens, notUsed, notUsed, noKey, &LocMenu[0]},
	
	{"&Cat", m_CatMenu, isSens, notUsed, notUsed, noKey, &CatMenu[0]},
	{"&Options", m_OptionMenu, isSens, notUsed, notUsed, noKey, &OptionMenu[0]},
	{"Help", m_HelpMenu, isSens, notUsed, notUsed, noKey, &HelpMenu[0]},
	
	
	{NULL}
      };
//@V@:EndMenu






//@V@:BeginCmdPane ToolBar
    static CommandObject ToolBar[] =
      {
	{C_Button,b_Plot,0,"Plot",NoList,CA_None,isSens,NoFrame,0,0},
	{C_Label, l_L1,0,"RA:",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	{C_TextIn, t_RAh, 0, "-000 00 00.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 13},
	//{C_TextIn, t_RAm, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 4},
	{C_Label, l_L1,0,"Dec:",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	{C_TextIn, t_Dec, 0, "-000 00 00.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 13},
	//{C_Label, l_L1,0,"VAng:",NoList,CA_None,isSens,NoFrame,0,0, 19,0},
	//{C_TextIn, t_VAng, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 4},
	{C_Label, l_L1,0,"Rot:",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	
	{C_TextIn, t_Rot, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 4},
	{C_Label, l_L1,0,"Time",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	{C_TextIn, t_GMTS, 0, "GMT:12:00 11/11/2000",
	          NoList,CA_None,isSens,NoFrame, 0, 0, 0},
	
	//{C_ProgressBar, pbrH, 50, "", NoList,
    //   CA_Horizontal,isSens,0, 0, 0},
	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
      };
//@V@:EndCmdPane


#ifdef WIN32
	static CommandObject ToolBar2[] =
      {
	{C_Button,b_Plot,0,"Plot",NoList,CA_None,isSens,NoFrame,0,0},
	{C_Label, l_L1,0,"Alt:",NoList,CA_None,isSens,NoFrame,0,0, 10,0},
	{C_TextIn, t_Alt, 0, "0.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 6},
	{C_Label, l_L1,0,"Az:",NoList,CA_None,isSens,NoFrame,0,0, 10,0},
	{C_TextIn, t_Az, 0, "45.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 6},
	{C_Label, l_LTimeZone,0,"Time:",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	{C_TextIn, t_GMT, 0, "GMT:12:00 11/11/2000",
	          NoList,CA_None,isSens,NoFrame, 0, 0, 0},
	//{C_Label, l_L1,0," LZT",NoList,CA_Small,isSens,NoFrame,0,0, 18,0},
	{C_TextIn, t_LZT, 0, "EDT:00:00:00 01-01", 
	          NoList,CA_None,isSens,NoFrame, 0, 0, 0},
	
	//{C_Label, l_L1,0,"Date:",NoList,CA_Small,isSens,NoFrame,0,0, 15,0},
	//{C_TextIn, t_Date, 0, "xxxxxxxxxx", NoList,CA_Small,isSens,NoFrame, 0, 0, 11},
	{C_Label, l_L1,0,"Julian:",NoList,CA_Small,isSens,NoFrame,0,0, 18},
	{C_TextIn, t_Julian, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 10},
	//{C_Label, l_L1,0," LZT",NoList,CA_Small,isSens,NoFrame,0,0, 18,0},
	//{C_TextIn, t_LZT, 0, "EDT:00:00:00 01-01-01", NoList,CA_Small,isSens,NoFrame, 0, 0, 9},
	//{C_TextIn, t_VAngAA, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 4},
	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
      };
#endif

#ifdef LINUX
	static CommandObject ToolBar2[] =
      {
	{C_Button,b_Plot,0,"Plot",NoList,CA_None,isSens,NoFrame,0,0},
	{C_Label, l_L1,0,"Alt:",NoList,CA_None,isSens,NoFrame,0,0, 10,0},
	{C_TextIn, t_Alt, 0, "0.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 6},
	{C_Label, l_L1,0,"Az:",NoList,CA_None,isSens,NoFrame,0,0, 10,0},
	{C_TextIn, t_Az, 0, "45.00", NoList,CA_Small,isSens,NoFrame, 0, 0, 6},
	{C_Label, l_L1,0,"GMT:",NoList,CA_None,isSens,NoFrame,0,0, 15,0},
	{C_TextIn, t_GMT, 0, "12:00", NoList,CA_Small,isSens,NoFrame, 0, 0, 5},
	{C_Label, l_L1,0,"Date:",NoList,CA_Small,isSens,NoFrame,0,0, 11,0},
	{C_TextIn, t_Date, 0, "11/11/1999", NoList,CA_Small,isSens,NoFrame, 0, 0, 10},
	{C_Label, l_L1,0,"Julian:",NoList,CA_Small,isSens,NoFrame,0,0, 15},
	{C_TextIn, t_Julian, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 11},
	//{C_Label, l_L1,0,"VAng:",NoList,CA_Small,isSens,NoFrame,0,0, 18,0},
	
	//{C_TextIn, t_VAngAA, 0, "00", NoList,CA_Small,isSens,NoFrame, 0, 0, 4},
	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
      };
#endif

//@V@:BeginStatPane StatBar
    static vStatus StatBar[] =
      {
	#ifdef WIN32
	{"  ", t_StatMessage, CA_None, isSens,250},
	{"  ", t_StatPosition, CA_None, isSens,110},
	#endif

	#ifdef LINUX
	{"  ", t_StatMessage, CA_Large, isSens,500},
	#endif
	{0,0,0,0,0}
      };
//@V@:EndStatPane

//====================>>> SCAuxTimer::TimerTick <<<====================
  void SCAuxTimer::TimerTick()
  {
	cmdw->WindowCommand(cmdAuxTimer, cmdAuxTimer, C_Button); // update clock
  }

//====================>>> SCCmdWindow::SCCmdWindow <<<====================
  SCCmdWindow::SCCmdWindow(char* name, int width, int height) :
    vCmdWindow(name, width, height)
  {
    UserDebug1(Constructor,"SCCmdWindow::SCCmdWindow(%s) Constructor\n",name)

    // The Menu Bar
    SCMenu = new vMenuPane(StandardMenu);
    AddPane(SCMenu);

    // The Command Pane
    SCCmdPane = new vCommandPane(ToolBar);
    AddPane(SCCmdPane);

	SCCmdPane2 = new vCommandPane(ToolBar2);
    AddPane(SCCmdPane2);

    // The Canvas
    VF = new SCCanvasPane(this);
    AddPane(VF);

    // The Status Bar
    SCStatus = new vStatusPane(StatBar);
    AddPane(SCStatus);

	//------------------------init timer params
	vt_TimeLapseMode = 0;	//0=off,1=0n
	vt_Intms = 2000;		//time interval, ms
	vt_dJulian = 1;			//time step julian

    _auxTimer = new SCAuxTimer(this);	// create aux timer
    //_auxTimer->TimerSet(500);		// 1/2 second intervals
	 _auxTimer->TimerStop();
    // Associated dialogs

    StatDlg = new SCDialog(this,name);
    LocDlg = new SCModalDialog(this,name);
	TLDlg = new CTimeLdlg(this,name);
	TimeDlg = new CTimeDatedlg(this,name);

	ProgBar= new ProgBarDialog(this,name);
    
    // Show Window

    ShowWindow();
    WindowCommand(cmdAuxTimer,cmdAuxTimer,C_Button);	// update clock
  
	ShowPane(SCCmdPane, 0);//1= show
	ShowPane(SCCmdPane2, 1);
	//ShowPane(SCStatus, 0);//hide stat for now
	//ShowPane(SCCmdPane2, 0);

	//init 
	
	//int ret = LoadBSCat();
	//int ret1 = LoadConLines();


//#############################################
	//init vc and vm vars
	vc_RAh = 13;
	vc_RAm = 0;
	vc_Dec = 55;
	vc_Rot = 0;
	vc_VAng = 90;
	vc_Mag = 7;
	vc_Day = 1;
	vc_Month = 11;
	vc_Year = 1999;
	vc_Hour = 0;
	vc_Alt = 45;
	vc_Az = 180;
	vc_JulianDate = 0;
	vc_Minute = 0;
	vc_LocLat = (float)42.33;
	vc_LocLong = (float)-83.0492;

	//view mode flags
	vm_CSegMode = 1;	//0=off,1==on
	vm_RAGridMode = 0;	//0=off, 1=on
	vm_AltAzGridMode = 1;//0=off, 1=on
	vm_StarLabMode = 0; //0=off,1=on
	vm_LegendMode = 0;		//0=off,1=on
	vm_ViewMode = 1;		//0=sky, 1=geo
	vm_ColorMode = 0;		//0=color, 1=BonW, 1=WonB
	vm_ViewCenterMode = 0;	//0=off, 1 = on
	vm_ConNameMode = 0;
	vm_StarNameMode = 0;
	//vm_AutoRecLoad = 0;
	vm_SymRefLev = 0;
	vm_VCenDia = 10;
	vm_RecordMode = 0;
	vm_StarStyle = 2;		//0=dot,1=,2=blob,3=med blob, 4= big blob
	vm_RecordMode = 0;
	vm_PlanetMode = 1;

	vo_ShowStatus = 1;		//show status bar
	vm_Equinox = 1;			//0=astromeric,1=J2000,2=D1950
	vm_PlanetLabel = 1;		//planetlabels on
	vm_ColorMode = 0;		//0=norm,1=whtonBlk,2=redonblk,4=black on white
	vm_CentricMode = 1;		//0=geocentric,1=topocentric

	vm_AutoBlobMode = 1;	//autoblob on
	vm_Lock = 0;			//0=unlocked
	vm_LockedObject=0;		//Object locked onto.

	vm_MousePos = 0;		//RAdec mode

	//vm_DayLightTimeMode = 0;//not day light time

	DebugLevel = 0;//debug messages levels

	//set to current time
	SetTimeNow();

	strcpy(vm_TZLabel,"EST ");
	vm_TimeZoneIndex =  4;
	vm_TimeZoneOffset = -4;
	UpDateToolBarS(0);
	
	//inits
	//LastStarIndex = 0;
	//
	Rootcmdw = this;

	//load init catalog and other data...
	LoadBSCat();
	LoadConLines();
	LoadConNames();
	LoadStarNames();

	//init canvas pain
	VF->SelectPlotDC(0);
	VF->ClearView();
	//PlotView();//just shows then clears?

	CondRePlot();
	 
//#############################################
	
	}

//====================>>> SCCmdWindow::~SCCmdWindow <<<====================
  SCCmdWindow::~SCCmdWindow()
  {
    UserDebug(Destructor,"SCCmdWindow::~SCCmdWindow() destructor\n")

    // Now put a delete for each new in the constructor.

    delete SCMenu;
    //delete SCCanvas;
	delete VF;
    delete SCCmdPane;
	delete SCCmdPane2;
    delete SCStatus;
    _auxTimer->TimerStop();	// end it
    delete _auxTimer;	// free it
    delete StatDlg;
    delete LocDlg;
	delete ProgBar;
	delete TLDlg;
  }

//====================>>> SCCmdWindow::KeyIn <<<====================
  void SCCmdWindow::KeyIn(vKey keysym, unsigned int shift)
  {
    vCmdWindow::KeyIn(keysym, shift);
  }

//====================>>> SCCmdWindow::WindowCommand <<<====================
  void SCCmdWindow::WindowCommand(ItemVal id, ItemVal val, CmdType cType)
  {
    // Default: route menu and toolbar commands here
	//float RAdeg;
	//char outstr[40];
    UserDebug1(CmdEvents,"SCCmdWindow:WindowCommand(%d)\n",id)

char mess[1000];

    switch (id)
      {

		case m_MousePosRD:
		{
			vm_MousePos = 0;
			SetValue(m_MousePosRD,1,Checked);
			SetValue(m_MousePosAA,0,Checked);
			break;
		}

		case m_MousePosAA:
		{
			vm_MousePos = 1;
			SetValue(m_MousePosRD,0,Checked);
			SetValue(m_MousePosAA,1,Checked);
			break;
		}

		case m_SetTime:
		{
		TimeDlg->dg_Hour = vc_Hour;
		TimeDlg->dg_Min = vc_Minute;
		TimeDlg->dg_Day = vc_Day;
		TimeDlg->dg_Month = vc_Month;
		TimeDlg->dg_Year = vc_Year;
		//vm_TimeZoneIndex = 2;
	
		TimeDlg->dd_TimeZoneIndex = vm_TimeZoneIndex;
	
	    
		ItemVal rval = TimeDlg->SCAction("Sample Modal Dialog");
	    
		if(rval == 1)
		{
			 vc_Hour = TimeDlg->dg_Hour;
			 vc_Minute = TimeDlg->dg_Min;
			 vc_Day = TimeDlg->dg_Day;
			 vc_Month = TimeDlg->dg_Month;
			 vc_Year = TimeDlg->dg_Year;
			 vm_TimeZoneIndex = TimeDlg->dd_TimeZoneIndex;
			 vm_TimeZoneOffset = TimeDlg->dd_TimeZoneOffset;
			 strcpy(vm_TZLabel,TimeDlg->dd_TimeZoneLabel);
		}
		UpDateToolBarS(0);
		PlotView();
		break;
	}

		

		case m_Print:
		{
			PrintSky();
			break;
		}

		case m_GotoMoon:{GotoObject(10);
						CondRePlot();
						break;}
		case m_GotoSun:{GotoObject(0);
						CondRePlot();
						break;}
		case m_GotoMercury:{GotoObject(1);
					 CondRePlot();
					 break;}
		case m_GotoVenus:{GotoObject(2);
					 CondRePlot();
					 break;}
		case m_GotoMars:{GotoObject(4);
					 CondRePlot();
					 break;}
		case m_GotoSaturn:{GotoObject(6);
					 CondRePlot();
					 break;}
		case m_GotoJupiter:{GotoObject(5);
					 CondRePlot();
					 break;}
		case m_GotoUranus:{GotoObject(7);
					 CondRePlot();
					 break;}
		case m_GotoNeptune:{GotoObject(8);
					 CondRePlot();
					 break;}
		case m_GotoPluto:{GotoObject(9);
					 CondRePlot();
					 break;}


case m_UnLock:
{
	vm_Lock = 0;
	break;
}

case m_LockSun:
{
	vm_Lock = 1;
	vm_LockedObject = 0;
	CondRePlot();
	break;
}

case m_LockMoon:
{
	vm_Lock = 1;
	vm_LockedObject = 10;
	CondRePlot();
	break;
}

case m_StopTimeLapse:
{
	StopTimer();
	break;
}


case m_SetTimeLapse:
{
	
	
	ItemVal rval = TLDlg->SCAction("Sample Modal Dialog");
	
	if(rval == 1)
	{
		//int counter
		TimeLapseCnt = 0;

		_auxTimer->TimerStop();//for good measure
		vt_TimeLapseMode = 1;					//0=off,1=0n
		vt_Intms = 1000 * (int)TLDlg->dd_Int + 200;		//time interval, ms
		vt_dJulian = TLDlg->dd_Day
					+ TLDlg->dd_Hour / 24
					+ TLDlg->dd_Min / (24 * 60);
		int dum = 1;
		_auxTimer->TimerSet(vt_Intms);
	}

	else//disable timer
	{
		_auxTimer->TimerStop();
		vt_TimeLapseMode = 0;
	}
	break;
}


	//@V@:Case m_ModalDialog
	case m_SetLocation:
	  {
		LocDlg->dd_LocLat = vc_LocLat;
		LocDlg->dd_LocLong = vc_LocLong;
	    
		ItemVal rval = LocDlg->SCAction("Sample Modal Dialog");
	    
		if(rval == 1)
		{
			 vc_LocLat = LocDlg->dd_LocLat;

			 //Hack to avoid error on Lat = 90
			 if(vc_LocLat > 89.99)
				 vc_LocLat = (float)89.99;
			 if(vc_LocLat < -89.99)
				 vc_LocLat = -(float)89.99;

			 vc_LocLong = LocDlg->dd_LocLong;
		}
		
		break;
	  }	//@V@:EndCase


case m_ColorNorm:
{
	//0=norm,1=whtonBlk,2=redonblk,3=black on white
	vm_ColorMode = 0;
	SetValue(m_ColorNorm,1,Checked);
	SetValue(m_ColorWonB,0,Checked);
	SetValue(m_ColorRonB,0,Checked);
	SetValue(m_ColorBonW,0,Checked);
	CondRePlot();
	break;
}

case m_ColorBonW:
{
	vm_ColorMode = 3;
	SetValue(m_ColorNorm,0,Checked);
	SetValue(m_ColorWonB,0,Checked);
	SetValue(m_ColorRonB,0,Checked);
	SetValue(m_ColorBonW,1,Checked);
	CondRePlot();
	break;
}

case m_ColorWonB:
{
	vm_ColorMode = 1;
	SetValue(m_ColorNorm,0,Checked);
	SetValue(m_ColorWonB,1,Checked);
	SetValue(m_ColorRonB,0,Checked);
	SetValue(m_ColorBonW,0,Checked);
	CondRePlot();
	break;
}

case m_ColorRonB:
{
	vm_ColorMode = 2;
	SetValue(m_ColorNorm,0,Checked);
	SetValue(m_ColorWonB,0,Checked);
	SetValue(m_ColorRonB,1,Checked);
	SetValue(m_ColorBonW,0,Checked);
	CondRePlot();
	break;
}

case m_Test:
{
	vNoticeDialog note(this);
	//VM.PlanetPosStr(mess,vc_JulianDate, vm_Equinox,vc_LocLat,vc_LocLong);
	VM.FigurePlanetInfo(vc_JulianDate,vm_Equinox,vm_CentricMode,
							  vc_LocLat, vc_LocLong,
							  cZenith);
		
	note.Notice(VM.PlanInfoStr);
	break;
}

case m_PlanetPositions:
{
	vNoticeDialog note(this);
	VM.FigurePlanetInfo(vc_JulianDate,vm_Equinox,vm_CentricMode,
						vc_LocLat, vc_LocLong,
						cZenith);
	note.Notice(VM.PlanInfoStr);
	break;
}



	case m_OpenSet:
	  {	
		OnOpenSet();
		CondRePlot();
	    //vNoticeDialog note(this);
	    //note.Notice("Open");
	    break;
	  }	


	case  m_SaveSet:
	  {
		OnSaveSet();
	    //vNoticeDialog note(this);
	    //note.Notice("Save");
	    break;
	  }	
 
	case  m_About:
	  {
		//OnSaveSet();
	    vNoticeDialog note(this);
	    note.Notice("starcat 0.96\n(C) 2001 Jim Campbell\njc@izzy.net\nhttp://www.izzy.net/~jc");
	    break;
	  }	
  
case  m_Help1:
{
	strcpy(mess,"Getting Started:\n");
	strcat(mess,"- Point and Left Click to Center View\n");
	strcat(mess,"  and navagate around sky.\n");
	strcat(mess,"- Drag Circle Area to Zoom In or Out. Drag\n");
	strcat(mess,"  from center to corner to zoom out somewhat.\n");
	strcat(mess,"- Point and Right Click at a Star or Oject\n");
	strcat(mess,"  to identify and get info\n");
	strcat(mess,"- [Nav][Zoom90] for wide view\n");
	strcat(mess,"- [View][ConNames] to show constellation names\n");
	strcat(mess,"- [View][RADecGrid] to show equatorial grid\n");	
	strcat(mess,"- [Object][Goto>][Moon] to find moon.\n");
	strcat(mess,"- [Time][+Hour] to advance time 1 Hour.\n");
	strcat(mess,"- [Time][SetTime...] To set Time,Date and Time Zone\n");
	strcat(mess,"- [Loc][Set Location] to set Geographic Location");
	//strcat(mess,"\n");
	vNoticeDialog note(this);
	note.Notice(mess);
	break;
}

case  m_Help2:
{
	strcpy(mess,"Catalog Menu:\n\n");
	strcat(mess,"- [Show Record] Shows catalog record data\n");
	strcat(mess,"  when a star is selected by right clicking.\n");
	strcat(mess,"- [Show Raw Record] Show catalog raw record\n");
	strcat(mess,"  string for selected star.\n");
	strcat(mess,"- [Load xxxx cat] loads selected catalog\n");
	strcat(mess,"  Condensed data file.\n");
	strcat(mess,"- [Util][Build xx_cond_cat] builds condensed data\n");
	strcat(mess,"  file from the catalog file\n\n");
	strcat(mess,"  Note: The condensed catalog files must be present to load.\n");	
	strcat(mess,"  These files can be built after downloading the catalogs.\n");
	strcat(mess,"  Also, the catalog files must be present to show data records.\n");
	strcat(mess,"  See readme file for details.\n\n");

	strcat(mess,"  To get the Hipparcos and Tycho Catalogs, goto:\n");
	strcat(mess,"  ftp://adc.gsfc.nasa.gov/pub/adc/archives/catalogs/1/1239/\n");
	strcat(mess,"    And Get: hip_main.dat.gz\n");
	strcat(mess,"             tyc_main.dat.gz\n\n");
	strcat(mess,"  To get the Bright Star Catalog, goto:\n");
	strcat(mess,"  ftp://adc.gsfc.nasa.gov/pub/adc/archives/catalogs/5/5050/\n");
	strcat(mess,"    And Get: catalog.dat.gz\n\n");

	strcat(mess,"  Ucompress the catalog files and put into the directory\n");
	strcat(mess,"  containing Starcat, then build the condensed data files.\n");
	//strcat(mess,"\n");
	vNoticeDialog note(this);
	note.Notice(mess);
	break;
}

	
	//@V@:Case M_Exit
	case M_Exit:
	  {
	    theApp->Exit();
	    break;
	  }	//@V@:EndCase


	//@V@:Case m_Dialog
	case m_Dialog:
	  {
	    if (!StatDlg->IsDisplayed())
		StatDlg->ShowDialog("Sample Modeless Dialog");
	    break;
	  }	//@V@:EndCase

	case m_ShowStatus:
	{
		if(vo_ShowStatus == 0)//then show stat
		{
			vo_ShowStatus = 1;
			SetValue(m_ShowStatus,0,Checked);
			ShowPane(SCStatus, 1);//hide stat for now
		}
		else
		if(vo_ShowStatus == 1)//then hide stat
		{
			vo_ShowStatus = 0;
			SetValue(m_ShowStatus,1,Checked);
			ShowPane(SCStatus, 0);//hide stat for now
		}
		//CondRePlot();
	    break;
	}




	//@V@:Case btnTestTool
	case b_Plot:
	  {
		//allow reading of tool bar in sky biew mode
		if(vm_ViewMode == 0)//SkyViewMode
		{
			UpDateToolBarS(1);
			UpDateToolBarS(0);
			PlotView();
		}
		//use only internal data for geo mode
		if(vm_ViewMode == 1)//GeoViewMode
		{
			UpDateToolBarS(0);
			PlotView();
		}
	  
	  /*		  
		  //UpDateToolBarS(1);
		  //PlotView();
		  if(vm_ViewMode == 0)//SkyViewMode
		  {
			UpDateToolBar1(1);
			//RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
			//VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng);
			PlotView();
			//UpDateToolBar1(0);
		  }
		  if(vm_ViewMode == 1)//GeoViewMode
		  {
			UpDateToolBar2(1);
			//RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
			//VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng);
			PlotView();
			//UpDateToolBar2(0);
		  }

  */
		
	    break;
	  }	//@V@:EndCase


	case VF_Message:
	  {
	    OnVFMessage();
	    break;
	  }

	case m_geocentric:
	  {	
		  vm_CentricMode = 0;	//0=geocentric,1=topocentric = 0;
		  SetValue(m_geocentric,1,Checked);
		  SetValue(m_topocentric,0,Checked);
	    break;
	  }	
	 case m_topocentric:
	  {	
		  vm_CentricMode = 1;
		  SetValue(m_geocentric,0,Checked);
		  SetValue(m_topocentric,1,Checked);
	    break;
	  }	
	case m_eqDate:
	  {	
		  vm_Equinox = 0;
		  SetValue(m_eqDate,1,Checked);
		  SetValue(m_eqJ2000,0,Checked);

	    break;
	  }	
	case m_eqJ2000:
	  {	
		  vm_Equinox = 1;
		  SetValue(m_eqDate,0,Checked);
		  SetValue(m_eqJ2000,1,Checked);

	    break;
	  }	
	 case m_Extra:
	  {	
		  if(DebugLevel == 0)
		  {
			  DebugLevel = 1;
			  SetValue(m_Extra,1,Checked);
		  }
		  else
		  {
			  DebugLevel = 0;
			  SetValue(m_Extra,0,Checked);
		  }

	    break;
	  }


	case m_PlanetLabel:
	  {	
		  if(vm_PlanetLabel == 0)
		  {
			vm_PlanetLabel = 1;
			SetValue(m_PlanetLabel,1,Checked);
		  }
		  else
		  {
			  vm_PlanetLabel = 0;
			  SetValue(m_PlanetLabel,0,Checked);
		  }

	    break;
	  }	

	case m_ShowRecord:
	{	
		//vm_RecordMode;		//0=off,1=PRec,2=RawRec
		if(vm_RecordMode == 0)
		{
			vm_RecordMode = 1;
			SetValue(m_ShowRecord,1,Checked);
			SetValue(m_ShowRawRecord,0,Checked);
		}
		else
		if(vm_RecordMode == 1)
		{
			vm_RecordMode = 0;
			SetValue(m_ShowRecord,0,Checked);
			SetValue(m_ShowRawRecord,0,Checked);
		}
		else
		if(vm_RecordMode == 2)
		{
			vm_RecordMode = 1;
			SetValue(m_ShowRecord,1,Checked);
			SetValue(m_ShowRawRecord,0,Checked);
		}
		break;
	}

	case m_ShowRawRecord:
	{
		//vm_RecordMode;		//0=off,1=PRec,2=RawRec
		if(vm_RecordMode == 0)
		{
			vm_RecordMode = 2;
			SetValue(m_ShowRecord,0,Checked);
			SetValue(m_ShowRawRecord,1,Checked);
		}
		else
		if(vm_RecordMode == 1)
		{
			vm_RecordMode = 2;
			SetValue(m_ShowRecord,0,Checked);
			SetValue(m_ShowRawRecord,1,Checked);
		}
		else
		if(vm_RecordMode == 2)
		{
			vm_RecordMode = 0;
			SetValue(m_ShowRecord,0,Checked);
			SetValue(m_ShowRawRecord,0,Checked);
		}
		break;
	}




	  case m_LoadHipCat:
	  {
		//LoadBSCat();
		char outstr[50];
		int ret;

		ret = LoadHipCat();
	
		sprintf( outstr, "Hip Loaded, NumStar:%d ",ret );
		StatDlg->PostMess(outstr);
		SetString(t_StatMessage, outstr);
		
	    break;
	  }

	  case m_LoadTycCat:
	  {
		//LoadBSCat();
		char outstr[50];
		int ret;

		ret = LoadTycCat();
	
		sprintf( outstr, "Tyc Loaded, NumStar:%d ",ret );
		StatDlg->PostMess(outstr);
		SetString(t_StatMessage, outstr);
	    break;
	  }

	case m_LoadBSCat:
	  {
		//LoadBSCat();
		char outstr[50];
		int ret,ret1,ret2;

		ret = LoadBSCat();
		ret1 = LoadConLines();
		ret2 = LoadConNames();
		//LoadConNames();
		LoadStarNames();

		sprintf( outstr, "NumStar:%d CLines:%d",ret,ret1 );
		StatDlg->PostMess(outstr);
		SetString(t_StatMessage, outstr);
	
	    break;
	  }

	case m_BuildBS:
	  {
		BuildBSCatCond();
	    break;
	  }

	  case m_BuildHip:
	  {
		BuildHipCatCond();
	    break;
	  }

	  case m_BuildTyc:
	  {
		BuildTycCatCond();
	    break;
	  }

///////////////////////////////////Styles
	case m_DotStyle:
	{
		vm_StarStyle = 0;		//0=dot,1=,2=blob,3=med blob, 4= big blob
		SetValue(m_DotStyle,1,Checked);
		SetValue(m_TickStyle,0,Checked);
		vm_AutoBlobMode = 0;
		SetValue(m_AutoBlob,0,Checked);
		CondRePlot();
		 break;
	}

	case m_TickStyle:
	{
		vm_StarStyle = 1;		//0=dot,1=,2=blob,3=med blob, 4= big blob
		SetValue(m_DotStyle,0,Checked);
		SetValue(m_TickStyle,1,Checked);
		vm_AutoBlobMode = 0;
		SetValue(m_AutoBlob,0,Checked);
		CondRePlot();
		 break;
	}

	case m_AutoBlob:
	{
		if(vm_AutoBlobMode == 0)
		{
			vm_AutoBlobMode = 1;
			SetValue(m_AutoBlob,1,Checked);
			vm_StarStyle = 2;		//0=dot,1=,2=blob,3=med blob, 4= big blob
			SetValue(m_DotStyle,0,Checked);
			SetValue(m_TickStyle,0,Checked);
		}
		else
		{
			vm_AutoBlobMode = 0;
			SetValue(m_AutoBlob,0,Checked);
		}
		break;
	}





/////////////////////////////////////
//target params
/////////////////////////////////////
	case m_10DegDia:
		{
			vm_VCenDia = 10;
			SetValue(m_10DegDia,1,Checked);
			SetValue(m_7DegDia,0,Checked);
			SetValue(m_5DegDia,0,Checked);
			SetValue(m_Telrad,0,Checked);
			CondRePlot();
			break;
		}

	case m_7DegDia:
		{
			vm_VCenDia = 7;
			SetValue(m_10DegDia,0,Checked);
			SetValue(m_7DegDia,1,Checked);
			SetValue(m_5DegDia,0,Checked);
			SetValue(m_Telrad,0,Checked);
			CondRePlot();
			break;
		}

	case m_5DegDia:
		{
			vm_VCenDia = 5;
			SetValue(m_10DegDia,0,Checked);
			SetValue(m_7DegDia,0,Checked);
			SetValue(m_5DegDia,1,Checked);
			SetValue(m_Telrad,0,Checked);
			CondRePlot();
			break;
		}

	case m_Telrad:
		{
			vm_VCenDia = -1;
			SetValue(m_10DegDia,0,Checked);
			SetValue(m_7DegDia,0,Checked);
			SetValue(m_5DegDia,0,Checked);
			SetValue(m_Telrad,1,Checked);
			CondRePlot();
			break;
		}

		
	case m_PlanetMode:
	{
		if(vm_PlanetMode == 0)
		{
			vm_PlanetMode = 1;
			SetValue(m_PlanetMode,1,Checked);
		}
		else
		if(vm_PlanetMode == 1)
		{
			vm_PlanetMode = 0;
			SetValue(m_PlanetMode,0,Checked);
		}
		CondRePlot();
	    break;
	}

	case m_ConLines:
	{
		if(vm_CSegMode == 0)
		{
			vm_CSegMode = 1;
			SetValue(m_ConLines,1,Checked);
		}
		else
		if(vm_CSegMode == 1)
		{
			vm_CSegMode = 0;
			SetValue(m_ConLines,0,Checked);
		}
		CondRePlot();
	    break;
	}


	  case m_RADecGrid:
	  {
	    if(vm_RAGridMode == 0)
		{
			vm_RAGridMode = 1;
			SetValue(m_RADecGrid,1,Checked);
		}
		else
		if(vm_RAGridMode == 1)
		{
			vm_RAGridMode = 0;
			SetValue(m_RADecGrid,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  case m_AltAzGrid:
	  {
	    if(vm_AltAzGridMode == 0)
		{
			vm_AltAzGridMode = 1;
			SetValue(m_AltAzGrid,1,Checked);
		}
		else
		if(vm_AltAzGridMode == 1)
		{
			vm_AltAzGridMode = 0;
			SetValue(m_AltAzGrid,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  case m_ViewCen:
	  {
	    if(vm_ViewCenterMode == 0)
		{
			vm_ViewCenterMode = 1;
			SetValue(m_ViewCen,1,Checked);
		}
		else
		if(vm_ViewCenterMode == 1)
		{
			vm_ViewCenterMode = 0;
			SetValue(m_ViewCen,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  case m_ConNames:
	  {
	    if(vm_ConNameMode == 0)
		{
			vm_ConNameMode = 1;
			SetValue(m_ConNames,1,Checked);
		}
		else
		if(vm_ConNameMode == 1)
		{
			vm_ConNameMode = 0;
			SetValue(m_ConNames,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  case m_StarNames:
	  {
	    if(vm_StarNameMode == 0)
		{
			vm_StarNameMode = 1;
			SetValue(m_StarNames,1,Checked);
		}
		else
		if(vm_StarNameMode == 1)
		{
			vm_StarNameMode = 0;
			SetValue(m_StarNames,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  case m_Legend:
	  {
	    if(vm_LegendMode == 0)
		{
			vm_LegendMode = 1;
			SetValue(m_Legend,1,Checked);
		}
		else
		if(vm_LegendMode == 1)
		{
			vm_LegendMode = 0;
			SetValue(m_Legend,0,Checked);
		}
		CondRePlot();
	    break;
	  }

	  


	case m_RePlot:
	  {
	    PlotView();
	    break;
	  }

	case m_ZoomIn:
	  {
	    ZoomIn();
		CondRePlot();
	    break;
	  }

	case m_ZoomOut:
	  {
	    ZoomOut();
		CondRePlot();
	    break;
	  }

	case m_Zoom90:
	  {
	    //float RAdeg;
		UpDateToolBarS(1);
		vc_VAng = 90;
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	case m_Zoom45:
	  {
	    //float RAdeg;
		UpDateToolBarS(1);
		vc_VAng = 45;
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	  case m_Now:
	  {
	    SetTimeNow();
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	  case m_UMin:
	  {
	    SetTimeDelta(1/(24.0*60.0));
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }
	   case m_DMin:
	  {
	    SetTimeDelta(-1/(24.0*60.0));
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	   case m_UHour:
	  {
	    SetTimeDelta(1/24.0);
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }
	   case m_DHour:
	  {
	    SetTimeDelta(-1/24.0);
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	   case m_UDay:
	  {
	    SetTimeDelta(1);
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }
	   case m_DDay:
	  {
	    SetTimeDelta(-1);
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }
	  case m_UTen:
	  {
	    SetTimeDelta(1/(24.0 * 6.0));
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }
	   case m_DTen:
	  {
	    SetTimeDelta(-1/(24.0 * 6.0));
		UpDateToolBarS(0);
		CondRePlot();
	    break;
	  }

	case m_Mag3:
	{
		vc_Mag = 3;
		ClearMagChecks();
		SetValue(m_Mag3,1,Checked);
		CondRePlot();
		break;
	}

	case m_Mag4:
	{
		vc_Mag = 4;
		ClearMagChecks();
		SetValue(m_Mag4,1,Checked);	
		CondRePlot();
		break;
	}
	case m_Mag5:
	{
		vc_Mag = 5;
		ClearMagChecks();
		SetValue(m_Mag5,1,Checked);	
		CondRePlot();
		break;
	}
	case m_Mag6:
	{
		vc_Mag = 6;
		ClearMagChecks();
		SetValue(m_Mag6,1,Checked);
		CondRePlot();
		break;
	}
	case m_Mag7:
	{
		vc_Mag = 7;
		ClearMagChecks();
		SetValue(m_Mag7,1,Checked);	
		CondRePlot();
		break;
	}
	case m_Mag8:
	{
		vc_Mag = 8;
		ClearMagChecks();
		SetValue(m_Mag8,1,Checked);	
		CondRePlot();
		break;
	}
	case m_Mag9:
	{
		vc_Mag = 9;
		ClearMagChecks();
		SetValue(m_Mag9,1,Checked);
		CondRePlot();
		break;
	}
	case m_Mag10:
	{
		vc_Mag = 10;
		ClearMagChecks();
		SetValue(m_Mag10,1,Checked);
		CondRePlot();
		break;
	}
	case m_Mag11:
	{
		vc_Mag = 11;
		ClearMagChecks();
		SetValue(m_Mag11,1,Checked);
		CondRePlot();
		break;
	}
	case m_Mag12:
	{
		vc_Mag = 12;
		ClearMagChecks();
		SetValue(m_Mag12,1,Checked);
		CondRePlot();
		break;
	}
	case m_Mag13:
	{
		vc_Mag = 13;
		ClearMagChecks();
		SetValue(m_Mag13,1,Checked);
		CondRePlot();
		break;
	}

	case m_ShowInfoBox:
	  {
	    if (!StatDlg->IsDisplayed())
		StatDlg->ShowDialog("Info");
	    break;
	  }

	   case m_GeoView:
	  {
		vm_ViewMode = 1;		//0=sky, 1=geo

		#ifdef WIN32
		//in windows you must show both
		//then hide the other to make work!!
		//otherwise it seems to leave SCCmdPane
		//on the top... How strange.
		ShowPane(SCCmdPane, 1);
		ShowPane(SCCmdPane2, 1);
		ShowPane(SCCmdPane, 0);
		#endif

		#ifdef LINUX
		//in linux you must hide all then show
		//in order wanted or it puts the toolbar
		//at the bottom!!!
        ShowPane(VF, 0);
		ShowPane(SCCmdPane, 0);
		ShowPane(SCCmdPane2, 0);
		ShowPane(SCStatus, 0);
        ShowPane(SCCmdPane2, 1);
		ShowPane(VF, 1);	
		ShowPane(SCStatus, 1);
		#endif

		//set check boxes
		SetValue(m_GeoView,1,Checked);
		SetValue(m_SkyView,0,Checked);

		

		UpDateToolBarS(0);
		CondRePlot();

		

	    break;
	  }

	   case m_SkyView:
	  {
		vm_ViewMode = 0;		//0=sky, 1=geo
		vc_Rot = 0;

		//turn RADec Grid on
		vm_RAGridMode = 1;
		SetValue(m_RADecGrid,1,Checked);
		
		//hide all pains, must be in this order inlinux of reshown toolbar
		//gets put at bottom!

		#ifdef WIN32
		//see notes for vm_GeoView above.
		ShowPane(SCCmdPane2, 1);
		ShowPane(SCCmdPane, 1);
		ShowPane(SCCmdPane2, 0);
		#endif

		#ifdef LINUX
        ShowPane(VF, 0);
		ShowPane(SCCmdPane, 0);
		ShowPane(SCCmdPane2, 0);
		ShowPane(SCStatus, 0);
        ShowPane(SCCmdPane, 1);
		ShowPane(VF, 1);	
		ShowPane(SCStatus, 1);
		#endif
	
		SetValue(m_GeoView,0,Checked);
		SetValue(m_SkyView,1,Checked);

		//also reset position to RA dec mode
		vm_MousePos = 0;
		SetValue(m_MousePosRD,1,Checked);
		SetValue(m_MousePosAA,0,Checked);

		UpDateToolBarS(0);
	
		CondRePlot();
	    break;
	  }

	



	//@V@:Case auxTimer
	case cmdAuxTimer:	// Event from aux timer
	  {
		OnTimer();
	    break;
	  }	//@V@:EndCase
	default:		// route unhandled commands up
	  {
	    vCmdWindow::WindowCommand(id, val, cType);
	    break;
	  }
      }
  }



void SCCmdWindow::ClearMagChecks()
{
	SetValue(m_Mag3,0,Checked);
	SetValue(m_Mag4,0,Checked);
	SetValue(m_Mag5,0,Checked);
	SetValue(m_Mag6,0,Checked);
	SetValue(m_Mag7,0,Checked);
	SetValue(m_Mag8,0,Checked);
	SetValue(m_Mag9,0,Checked);
	SetValue(m_Mag10,0,Checked);
	SetValue(m_Mag11,0,Checked);
	SetValue(m_Mag12,0,Checked);
	SetValue(m_Mag13,0,Checked);
}

void SCCmdWindow::OnMTest()
{
	float RAdeg;



	RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng,vm_ColorMode);

	//SCCanvas->SetViewSizeParam(100, 100);

	VF->ClearView();

	VF->PutStar(50, 50, 1, 0, 0);
	VF->PutStar(75, 50, 1, 0, 0);
	VF->PutStar(75, 75, 0, 0, 0);

	StatDlg->PostMess("DlgTest");

	UpDateToolBar1(1);
	RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng, vm_ColorMode);
	VF->PlotGrid();
	UpDateToolBar1(0);


	//UpDateToolBar1(1);
	//vc_VAng *= 1.5;
	//UpDateToolBar1(0);
	//VF->Test();
}

//////////////////////////////////////////
//UpDateToolBarS(int n)
// updates toolbar and vc vars
// sets julian time params
//  if n = 1, toolbar to data
//  if n = 0, data to toolbar
//////////////////////////////////////////
void SCCmdWindow::UpDateToolBarS(int n)
{
	if (vm_ViewMode == 0)//skyview mode
	{
		UpDateToolBar1(n);
	}
	else
	if (vm_ViewMode == 1)//geo mode
	{
		if(n == 1)//tool bar to data
		{
			UpDateToolBar2(1);	//get tool bar data
			SetJulian();		//set julian time param
			UpDateToolBar2(0);	//update tool bar

		}
		else if(n == 0)//data to toolbar
		{
			SetJulian();		//set julian time param
			UpDateToolBar2(0);	//update tool bar
		}
	}


}
//////////////////////////////////////////
//UpDateToolBar1(int n)
// for geo view
// updates toolbar and vc vars
//  if n = 1, toolbar to data
//  if n = 0, data to toolbar
//
//  Note:Does not update VMRA and VM_Dec currently
//////////////////////////////////////////
void SCCmdWindow::UpDateToolBar1(int n)
{
	char outstr[20],timestr[40];
	//char buff[20];
	float RAdeg;

	if(n == 0)
	{
		RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
		outstr[0] = '\0';
		VM.RAStr(RAdeg ,outstr);
		SetString(t_RAh,outstr);

		outstr[0] = '\0';
		VM.DecStr(vc_Dec,outstr);
		SetString(t_Dec, outstr);

		sprintf( outstr, "%4.0f",vc_Rot );
		SetString(t_Rot, outstr);

		//build time display string
		strcpy(timestr,"GMT ");
		sprintf( outstr, "%2d:%02d ",(int)vc_Hour,(int)vc_Minute );
		strcat(timestr,outstr);
		sprintf( outstr, "%02d/%02d/%04d  ",(int)vc_Month,(int)vc_Day,(int)vc_Year );
		strcat(timestr,outstr);
		SetString(t_GMTS, timestr);

	}
	else
	if(n == 1)
	{
		//SCCmdPane->GetTextIn(t_RAh , outstr,20);
		//sscanf(outstr,"%f",&vc_RAh);

		//SCCmdPane->GetTextIn(t_RAm , outstr,20);
		//sscanf(outstr,"%f",&vc_RAm);

		//SCCmdPane->GetTextIn(t_Dec , outstr,20);
		//sscanf(outstr,"%f",&vc_Dec);

		//SCCmdPane->GetTextIn(t_VAng , outstr,20);
		//sscanf(outstr,"%f",&vc_VAng);

		SCCmdPane->GetTextIn(t_Rot , outstr,20);
		sscanf(outstr,"%f",&vc_Rot);
	}
}
//////////////////////////////////////////
//UpDateToolBar2(int n)
//  for alt az view
// updates toolbar and vc vars
//  if n = 1, toolbar to data
//  if n = 0, data to toolbar
//////////////////////////////////////////
void SCCmdWindow::UpDateToolBar2(int n)
{
	char outstr[20],timestr[40];
	float d1,d2,d3;

	

	if(n == 0)
	{


		sprintf( outstr, "%6.2f",vc_Alt );
		SetString(t_Alt, outstr);

		//Hack to fix gridline errors on spec case az=0
		//this part just shows zero when Az set very small
		if(vc_Az <= .01)
		{
			sprintf( outstr, "%6.2f",0.0 );
			SetString(t_Az, outstr);
		}
		else
		{
			sprintf( outstr, "%6.2f",vc_Az );
			SetString(t_Az, outstr);
		}


		//build time display string
		strcpy(timestr,"GMT ");
		sprintf( outstr, "%2d:%02d ",(int)vc_Hour,(int)vc_Minute );
		strcat(timestr,outstr);
		sprintf( outstr, "%02d/%02d/%04d  ",(int)vc_Month,(int)vc_Day,(int)vc_Year );
		strcat(timestr,outstr);
		SetString(t_GMT, timestr);

		//build zone time string display
		Setvm_TZLabel(vm_TimeZoneOffset);
		SetString(t_LZT, vm_LZT);
		


		sprintf( outstr, "%10.2f",vc_JulianDate );
		SetString(t_Julian, outstr);

	}
	else
	if(n == 1)
	{
		SCCmdPane2->GetTextIn(t_Alt , outstr,20);
		sscanf(outstr,"%f",&d1);
		vc_Alt = (double)d1;

		SCCmdPane2->GetTextIn(t_Az , outstr,20);
		sscanf(outstr,"%f",&d1);
		//vc_Az = (double)d1;

		//hack again...
		if(d1 < .01)
		{
			vc_Az = .01;
		}
		else
		{
			vc_Az = (double)d1;
		}

		SCCmdPane2->GetTextIn(t_GMT , outstr,20);
		sscanf(outstr,"%2f:%2f",&d1,&d2);
		vc_Hour = d1;
		vc_Minute = d2;

		SCCmdPane2->GetTextIn(t_Date , outstr,20);
		sscanf(outstr,"%2f/%2f/%4f",&d1,&d2,&d3);
		vc_Month = (int)d1;
		vc_Day = (int)d2;
		vc_Year = (int)d3;	
	}
}


//////////////////////////////////////////
//PlotView()
// Interface to PrintPlotView
// in screen mode Note, PlotView was the
// only plot method. When printPlotView
// was added,  for plotting to the print dc
// this is kept as the interface
// for window plotting...
//  
//////////////////////////////////////////
void SCCmdWindow::PlotView()
{
	PrintPlotView(1);//1=send to canvas
}

//////////////////////////////////////////
//PrintPlotView()
// Plots view based on vc_ and vm_ Params
//  Dest = 1, plots to memDC
//  Dest = 0, plots to printer DC 
//
//Note, julian time must be set before calling.
//  
//////////////////////////////////////////
void SCCmdWindow::PrintPlotView(int Dest)
{
	STARDATA	Star,S1,S2;
	RECTVEC FC;
	int i,Num;
	float minMag,maxMag;
	float RAdeg;
	//float SVRAd;
	bool PSRet;
	char outstr[70];

	//set plot memDC or PrintDC
	if(Dest == 1)
		VF->SelectPlotDC(1);//memDC
	else
		VF->SelectPlotDC(2);//PrintDC



	//Hack to fix gridline errors on spec case az=0
	if(vc_Az < .01)
	{
		vc_Az = .01;
	}

	//if Lock mode on, get planet
	//positions and point to object
	if(vm_Lock == 1)
	{
		//figure planet positions now
		VM.FigurePlanetInfo(vc_JulianDate,vm_Equinox,vm_CentricMode,
							vc_LocLat, vc_LocLong,
							cZenith);

		GotoObject(vm_LockedObject);
	}


	
	//set vc params if in geo view mode
	if(vm_ViewMode == 1)
	{
		SetRADecfromAltAz();//sets mv_julian date as well
	}		//0=sky, 1=geo

	

	//set toolbar data;
	//UpDateToolBarS(0);//data to toolbar

	//set VF parmas to view canvas
	RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng,vm_ColorMode);

	//output stat message
	sprintf( outstr, "Plotting" );
	//StatDlg->PostMess(outstr);
	SetString(t_StatMessage, outstr);

	//clear the view canvas
	//VF->ClearView();
	VF->ClearView();

	//if autoblob size mode, set them now
	if(vm_AutoBlobMode == 1)
	{
		SetAutoBlob();
	}

	//Plot RADec Grid
	if(vm_RAGridMode == 1)
	{
		SetString(t_StatMessage, "Plotting RA Grid");
		theApp->CheckEvents();//moved to PostMess...ok
		VF->SetGenPen(2);
		VF->PlotGrid();	
				
	}

	//Plot AltAz grid and horizon
	if(vm_ViewMode == 1)
	{
		//stat mess
		SetString(t_StatMessage, "Plotting Alt Az Grid");
		theApp->CheckEvents();//moved to PostMess...ok

		VF->PlotHorizon(cZenith);
		VF->PlotHorizonCompLabels(cZenith);

		if(vm_AltAzGridMode == 1)
		{
			VF->PlotAltAzGrid(cZenith);	
		}
	}


	//if enabled, plot constalation lines
	//do these first so the stars will cover them
	if (vm_CSegMode == 1)
	{
		//output status
		SetString(t_StatMessage, "Plotting Con Lines");
		theApp->CheckEvents();//moved to PostMess...ok
		
		VF->SetGenPen(1);

		for (i=1;i<SC.NumCSeg+1;i++)
		{
			//todo plot conlines
			S1.RA = SC.ConLine[i][0];
			S1.Dec = SC.ConLine[i][1];
			S2.RA = SC.ConLine[i][2];
			S2.Dec = SC.ConLine[i][3];
			VF->PlotSeg(S1,S2);
		}
	}


	//plot legend
	if(vm_LegendMode == 1)
	{
		VF->PlotLegend(vm_StarStyle, (int)vc_Mag);
	}

		//plot legend
	if(vm_ViewCenterMode == 1)
	{
		if(vm_VCenDia == -1)//telrad
		{
			VF->PlotViewCenter(0);
			VF->PlotViewCenter(4 / 2);
			VF->PlotViewCenter(2 / 2);
			VF->PlotViewCenter(.5 / 2);
		}
		else//dia mode
		{
			VF->PlotViewCenter(0);
			VF->PlotViewCenter(vm_VCenDia / 2);
		}
	}

	//Plot stars in sky
	//and adds polor position of star in view frame
	//to VSList
	//SCD.ClearVSList();		//clear viewed star list
	
	STARDATA	Org;
	int			NumSPlot;

	//VF->SelectPlotDC(1);

	//Init org position stardata type
	Org.RA = 0;
	Org.Dec = 0;
	Org.Mag = 0;
	SC.ClearVSList();//clear the viewed star list
	NumSPlot = 0;
	minMag = 15;
	maxMag = -2;

	int count = SC.NumStar + 1;
	for(i=1;i<count;i++)
	{
		//generate stat,,,Doesn't update till end!!!
		//sprintf( outstr, "Stars Plotted:%d",NumSPlot );
		//SetString(t_StatMessage, outstr);		
		//UpdateView(vWindow* sender, int hint, void* pHint)
		//UpdateViews(0, 0, 0);
		//int pstat = i / 100;
		//StatDlg->SetValue(1002,pstat,Value);// prog bar
		if((float)i/1000 == i/1000)
		{
			sprintf( outstr, "Plotting Stars:%d/%d/%d",NumSPlot,i,count );
			StatDlg->PostMess(outstr);
			SetString(t_StatMessage, outstr);
			theApp->CheckEvents();//moved to PostMess...ok
		}

		Star = SC.GetStar(i);
		if (Star.Mag < vc_Mag)
		{
			Num = 0;
			//if (VDD.StarLabMode == 1)
			//Num = i;
			PSRet = VF->PlotStar(Star,vm_StarStyle,0);
			if(PSRet)
			{
				NumSPlot += 1;					//inc number stars plotted
				FC = VF->GetPSPosFC(Star);		//get plotted x,y position
				SC.PutVSList((int)FC.x,(int)FC.y,i);		//and add to VSList	
				if(Star.Mag > maxMag)			//update maxMag
					maxMag = Star.Mag;
				if(Star.Mag < minMag)			//update minMag
					minMag = Star.Mag;
			}
		}
	}

	//VF->SelectPlotDC(1);
	//VF->ClearView();

	//plot planets, sun, moon
	int Object,xpos,ypos;
	STARDATA ObjSTAR;
	double ObjRAdeg,ObjDec,ObjDia,ObjDist;
	double ObjAlt, ObjAz,ObjL, ObjB,ObjR;
	if(vm_PlanetMode == 1)
	{
		VM.FigurePlanetInfo(vc_JulianDate,vm_Equinox,vm_CentricMode,
							  vc_LocLat, vc_LocLong,
							  cZenith);

		for(Object=0;Object<=10;Object++)
		{
			if(Object !=3)
			{
				//VM.GetObjectData(Object,vc_JulianDate,vm_Equinox,
				//		   &ObjRAdeg,&ObjDec,&ObjDia);
				VM.GetPlanetInfo(Object,&ObjRAdeg,
								&ObjDec,&ObjDia,&ObjDist,
								&ObjAlt, &ObjAz,
								&ObjL, &ObjB,&ObjR);

				ObjSTAR.RA = (float)ObjRAdeg;
				ObjSTAR.Dec = (float)ObjDec;
				if( VF->PlotObject(ObjSTAR,Object,0,(float)ObjDia,vm_PlanetLabel,&xpos,&ypos) )
				{
					SC.PutVObjList(Object,xpos,ypos,(float)ObjRAdeg,(float)ObjDec,0,0);
				}
			}
		}
	}

	//plot con names
	char SName[20];
	STARDATA NPos;
	if (vm_ConNameMode == 1)
	{
		VF->SetGenPen(1);

		for (i=1;i<SC.NumConName+1;i++)
		{
			//plot con names
			SC.GetConName(SName,i);
			NPos = SC.GetConNPos(i);
			VF->PlotTextS(SName, NPos,0,0,1,1);						 
		}
	}


	//plot star names
	if (vm_StarNameMode == 1)
	{
		for (i=1;i<SC.NumStarName+1;i++)
		{
			//plot con names
			
			SC.GetStarName(SName,i);
			NPos = SC.GetStarNPos(i);
			VF->PlotTextS(SName, NPos,0,0-6,1,6);						 
		}
	}

	if(Dest == 1)
		VF->UpdateCanvasDC();

	char report[200];

	//generate stat
	sprintf( outstr, "Stars Plotted:%d",NumSPlot );
	strcpy(report,outstr);
	strcat(report,"   View Center:");

	RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;

	//Output position formated
	strcat(report,"RA=");
	VM.RAStr(RAdeg,outstr);
	strcat(report,outstr);
	strcat(report," Dec=");
	VM.DecStr(vc_Dec,outstr);
	strcat(report,outstr);


	SetString(t_StatMessage, report);

	
	//generate plot report

	sprintf( outstr, "Stars Plotted=%d\n",NumSPlot );
	strcpy(report,outstr);
	sprintf( outstr, "MaxMag=%5.2f\n",maxMag );
	strcat(report,outstr);
	sprintf( outstr, "MinMag=%5.2f\n",minMag );
	strcat(report,outstr);

	//Output center formated
	strcat(report,"\nView Center=\n");
	strcat(report,"RA=");
	VM.RAStr(RAdeg,outstr);
	strcat(report,outstr);strcat(report,"\n");
	strcat(report,"Dec=");
	VM.DecStr(vc_Dec,outstr);
	strcat(report,outstr);strcat(report,"\n");

	if(vm_ViewMode == 1)//if geo view mode
	{
		sprintf( outstr, "Alt=%6.2f\nAz=%6.2f\n"
			,vc_Alt,vc_Az );
		strcat(report,outstr);
	}

	strcat(report,"\nView Param=\n");
	sprintf( outstr, "ViewAngle=%5.2f\nRotAngle=%03.1f\n"
			,vc_VAng,vc_Rot );
	strcat(report,outstr);

	//show plot report in info box
	StatDlg->PostMess(report);


}

////////////////////////////////////////////////////////
//PrintSky()
// sets vc_JulianDate
//fromvc_Day;vc_Month;
//           vc_Year;
//           vc_Hour
//           vm_TimeZone vm_DayLightTimeMode
////////////////////////////////////////////////////////
void SCCmdWindow::SetJulian()
{
	//set julian date
	double Hour = vc_Hour + vc_Minute / 60;
	vc_JulianDate = VM.N.julian_date(vc_Year,vc_Month,vc_Day,Hour);
	
}


//////////////////////////////////////////////////
//SetRADecfromAltAz()
// Uses:	vc_Day,vc_Month,vc_Year,vc_Hour,vc_Alt,vc_Az
///         vc_LocLat,vc_LocLong
// Sets:    vc_RAm,vc_Dec,vc_Rot and julian date
//
//
//
///////////////////////////////////////////////////
void SCCmdWindow::SetRADecfromAltAz()
{
	int i;

	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;


	//set julian date NOW DONE BEFORE CALLING
	//double Hour = vc_Hour + vc_Minute / 60;
	//vc_JulianDate = VM.N.julian_date(vc_Year,vc_Month,vc_Day,Hour);
	//UpdateData(FALSE);

	RECTVEC Zgr = {0,0,1};		//geo rect zenith 
	RECTVEC Ngr = {1,0,0};		//geo rect north
	

	//find angle ,A1, between zenith and north pole star
	//(since NPSga must be zero, this could have been easier!)
	ALTAZVEC NPSga;	//
	VM.Celest2AltAz(vc_LocLat,vc_LocLong,vc_JulianDate,
					0.0,90.0,NPSga.Alt,NPSga.Az);
	RECTVEC   NPSgr = VM.AltAztoRect(NPSga.Alt,NPSga.Az);
	float A1;		//angle between grz and crnp
	A1 = (float)(RtoD * acos(VM.DotProd(Zgr,NPSgr)) );



	//now find angle zenith must be rotated about
	//the nort pole star vector to be in plane of
	//north pole star vector and RA=0, Dec = 0.
	ALTAZVEC RDZga;
	VM.Celest2AltAz(vc_LocLat,vc_LocLong,vc_JulianDate,
					0.0,0.0,RDZga.Alt,RDZga.Az);
	RECTVEC   RDZgr = VM.AltAztoRect(RDZga.Alt,RDZga.Az);

	RECTVEC g1 = VM.CrossProd(NPSgr,Zgr);
	RECTVEC g2 = VM.CrossProd(g1,NPSgr);

	float B1 = (float)RtoD * (float)acos(VM.DotProd(RDZgr,g2)/
							(VM.RectMag(RDZgr)
							* VM.RectMag(g2) ) );

	//will need test for complete circle here
	//if this cross is same dir as NPSgr then
	//range is 0 to 180, if opposite dir range is
	//180 to 360.  (This method mat give a fault if
	//geo loc is at either pole.)
	RECTVEC	test;
	test = VM.CrossProd(RDZgr,g2);
	if((test.x/NPSgr.x) < 0)
		B1 = 360 - B1;


	//assemble Zc, celest coors of zenith
	STARDATA Zc;
	Zc.RA = B1;
	Zc.Dec = 90 - A1;


	//now get RA,Dec of AltAz view point
	ALTAZVEC VPga;
	VPga.Alt = vc_Alt;
	VPga.Az = vc_Az;

	STARDATA VPc;
	float TDist = (float)(90 - VPga.Alt);
	float TAng = (float)VPga.Az;//360 - VPga.Az;
	VPc = VM.VecRot(Zc,TDist,TAng);

	//now get RA,Dec of d(AltAz view point)
	ALTAZVEC dVPga;
	dVPga.Alt = vc_Alt + 1;
	dVPga.Az = vc_Az;

	STARDATA dVPc;
	TDist = (float)(90 - dVPga.Alt);
	TAng = (float)dVPga.Az;
	dVPc = VM.VecRot(Zc,TDist,TAng);

	//and finally find Rot angle of view
	POLARVEC RelDistAng;
	RelDistAng = VM.DistVec(VPc,dVPc);
	float RotAng = (float)RelDistAng.Ang;
	//correct for result = 360
	if (RotAng >=360) RotAng = RotAng - 360;
	
i=1;
	//set RA,Dec Rot view params
	//UpdateData(TRUE);
	vc_Dec = VPc.Dec;
	float RA = VPc.RA;
	if(RA < 0) RA = RA + 360;
	vc_RAh = (float)((int)(RA/15));
	vc_RAm =(RA - vc_RAh * 15) * 4;

	vc_Rot = 360 - RotAng;

	//set global view params
	cZenith = Zc;
	cViewPoint = VPc;

	//generate debug reports
	//UpdateData(FALSE);
	//sprintf( outstr, "Debug Data: Zc.RA=%f Zc.Dec=%f ",
	//		Zc.RA,Zc.Dec);
	//m_message = outstr;
	//sprintf( outstr, "VPc.RA=%f VPc.Dec=%f ",
	//		VPc.RA,VPc.Dec);
	//m_message = m_message + outstr;
	//sprintf( outstr, "dVPc.RA=%f dVPc.Dec=%f ",
	//		dVPc.RA,dVPc.Dec);
	//m_message = m_message + outstr;
	//sprintf( outstr, "RotAng=%f ",
	//		RotAng);
	//m_message = m_message + outstr;
	//UpdateData(FALSE);
}

void SCCmdWindow::ZoomIn()
{
	//float RAdeg;
	UpDateToolBarS(1);
	vc_VAng /= 1.5;
	UpDateToolBarS(0);
	//RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	//VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng);
	//CondRePlot();

}

void SCCmdWindow::ZoomOut()
{
	//float RAdeg;
	UpDateToolBarS(1);
	vc_VAng *= 1.5;
	UpDateToolBarS(0);
	//RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	//VF->SetViewParam(RAdeg,vc_Dec,vc_Rot,vc_VAng);
	//CondRePlot();

}

//////////////////////////////////////////////////
//OnVFMessage()
//  Responds to mouse action in canvas wn.	
//       
// 
//
//
//
///////////////////////////////////////////////////
void SCCmdWindow::OnVFMessage()
{
	char outstr[50];
	char message[200];
	//CString OutStr;
	float RA;	
	//float DistFC;
	POLARVEC DVec;
	ALTAZVEC aVSPos;
	STARDATA cVSPos;
	int index;
	double v_Alt;
	double v_Az;
	//float v_RAh,v_RAm,v_RAs;
	//float v_Decd,v_Decm,vDecs;


	

	int n,x,y;
	//StatPosition write test
	if(VF->VFMessActType == 10		//10=mouse motion
	    && vt_TimeLapseMode == 0)	//and timelapse mode off
	{
		n = VF->MoveCounter;
		x =VF->Mx;
		y =VF->My;

		//build RA Dec pointer location string
		if(vm_MousePos == 0)//RA dec mode
		{
			strcpy(message,"RA ");
			VM.RAStr(VF->SMPos.RA,outstr);
			strcat(message,outstr);
			strcat(message, " Dec ");
			VM.DecStr(VF->SMPos.Dec,outstr);
			strcat(message,outstr);
		}
		
		//build alt az position display
		if(vm_MousePos == 1)//AltAz Mode
		{
				VM.Celest2AltAz(vc_LocLat,vc_LocLong,
								 vc_JulianDate,
								 (double)VF->SMPos.RA,(double)VF->SMPos.Dec,
								 v_Alt,v_Az);
				sprintf( outstr, "Alt=%-6.2f Az=%-6.2f",
						 v_Alt,v_Az);
				strcpy(message,outstr);
		}


		//sprintf( outstr, "%d %d\n",x,y );
		SetString(t_StatPosition, message);
	}


	//if time lapse on and not a mouse motion
	//type message, just stop time lapse
	if(vt_TimeLapseMode == 1 && 
		VF->VFMessActType != 10)
	{
		StopTimer();
		return;
	}
 

	if(VF->VFMessActType == 1)//1=center
	{
		if(vm_ViewMode == 0)	//sky view mode
		{
			//sky viewmode
			//center on clicked position
			vc_Dec = VF->SMUp.Dec; 
			RA = VF->SMUp.RA;
			if(RA < 0) RA = RA + 360;
			vc_RAh = (float)((int)(RA/15));
			vc_RAm =(RA - vc_RAh * 15) * 4;
			UpDateToolBar1(0);
			PlotView();
		}
		else if (vm_ViewMode == 1) 
		{
			//geo viewmode
			//get alt az of view center and update
			//view params before reploting
			VM.Celest2AltAz(vc_LocLat,vc_LocLong,
								 vc_JulianDate,
								 (double)VF->SMUp.RA,(double)VF->SMUp.Dec,
								 v_Alt,v_Az);

			vc_Alt = v_Alt;
			vc_Az = v_Az;

			UpDateToolBar2(0);
			PlotView();
		}
	}


	else
	if(VF->VFMessActType == 2)//zoom on window
	{
		if(vm_ViewMode == 0)	//sky view mode
		{
			//set box center to view center
			vc_Dec = VF->SMDown.Dec; 
			RA = VF->SMDown.RA;
			if(RA < 0) RA = RA + 360;
			vc_RAh = (float)((int)(RA/15));
			vc_RAm =(RA - vc_RAh * 15) * 4;

			//set view ange to mouse down to up angle
			DVec = VM.DistVec(VF->SMDown,VF->SMUp);
			vc_VAng = 2 * (float)DVec.Rad;

			UpDateToolBar1(0);
			PlotView();
		
		}
		else if (vm_ViewMode == 1) //geo view mode
		{
			//set box center to view center
			ALTAZVEC NPSga;	//
			VM.Celest2AltAz(vc_LocLat,vc_LocLong,
							vc_JulianDate,
							VF->SMDown.RA,VF->SMDown.Dec,
							NPSga.Alt,NPSga.Az);

			vc_Alt = NPSga.Alt;
			vc_Az = NPSga.Az;

			//set view ange to mouse down to up angle
			DVec = VM.DistVec(VF->SMDown,VF->SMUp);
			vc_VAng = 2 * (float)DVec.Rad;

			UpDateToolBar2(0);
			PlotView();
	
		}
	}

	else
	if(VF->VFMessActType == 3)//id closest star
	{

		index = SC.GetVS_ID(VF->MDownx,VF->MDowny);

		if(index == 0)//nothing fond display click position
		{
			if(vm_ViewMode == 0)	//sky view mode
			{
				
				//report cursor position
				
				message[0] = '\0';
				strcat(message,"Pointer Position:\nRA=");
				VM.RAStr(VF->SMUp.RA,outstr);
				strcat(message,outstr);strcat(message,"\n");
				strcat(message,"Dec=");
				VM.DecStr(VF->SMUp.Dec,outstr);
				strcat(message,outstr);strcat(message,"\n");

				if(DebugLevel >=1)
				{
					//output RAdeg,Dec formated data
					strcat(message,"\nPos(RAdeg,Dec)=\n");
					sprintf( outstr, "%-6.2f %-6.2f\n",
							VF->SMUp.RA,VF->SMUp.Dec);
					strcat(message,outstr);
				}



				//LastStarIndex = 0;
				StatDlg->PostMess(message);
				StatDlg->ShowDialog("Info");
			
			}
			else if (vm_ViewMode == 1) //geo view mode
			{
				//report cursor both coords
				//get lat ong of cursor
				//geo viewmode
				VM.Celest2AltAz(vc_LocLat,vc_LocLong,
								 vc_JulianDate,
								 (double)VF->SMUp.RA,(double)VF->SMUp.Dec,
								 v_Alt,v_Az);

				//VM.RAdeg2RAhm(VF->SMUp.RA,v_RAh,v_RAm);	
				//sprintf( outstr, "Pointer Position:\nRA=%d:%04.1f\nDec=%-6.2f\n",
				//		 (int)v_RAh,v_RAm,VF->SMUp.Dec);

				message[0] = '\0';
				strcat(message,"Pointer Position:\nRA=");
				VM.RAStr(VF->SMUp.RA,outstr);
				strcat(message,outstr);strcat(message,"\n");
				strcat(message,"Dec=");
				VM.DecStr(VF->SMUp.Dec,outstr);
				strcat(message,outstr);strcat(message,"\n");


				sprintf( outstr, "Alt=%-6.2f\nAz=%-6.2f\n",
						 v_Alt,v_Az);
				strcat(message,outstr);

				//output RAdeg,Dec formated data
				if(DebugLevel >=1)
				{
					strcat(message,"\nPos(RAdeg,Dec)=\n");
					sprintf( outstr, "%-6.2f %-6.2f\n",
							VF->SMUp.RA,VF->SMUp.Dec);
					strcat(message,outstr);
				}

				StatDlg->PostMess(message);
				StatDlg->ShowDialog("Info");	
			}
		}

		else
		if(index > 0)//index must >0, star found
		{
			if(vm_ViewMode == 0)	//sky view mode
			{
				//get star RA,Dec
				cVSPos = SC.GetStar(index);

				//plot highlighted star in yellow
				VF->SelectPlotDC(0);//print to window
				VF->PlotStar(cVSPos,vm_StarStyle,6);
				VF->PlotStar(cVSPos,10,6);

				if(vm_RecordMode == 0)
				{
					//report found star info
					sprintf( outstr, "Star id=%d\n",
							SC.GetStarID(index) );
					message[0] = '\0';
					strcat(message,outstr);

					//VM.RAdeg2RAhm(cVSPos.RA,v_RAh,v_RAm);
					//sprintf( outstr, "RA=%d:%04.1f\nDec=%-6.2f\nMag=%-6.2f\n",
					//		(int)v_RAh,v_RAm,cVSPos.Dec,cVSPos.Mag);
					//strcat(message,outstr);

					strcat(message,"RA=");
					VM.RAStr(cVSPos.RA,outstr);
					strcat(message,outstr);strcat(message,"\n");
					strcat(message,"Dec=");
					VM.DecStr(cVSPos.Dec,outstr);
					strcat(message,outstr);strcat(message,"\n");

					sprintf( outstr, "Mag=%-6.2f\n",cVSPos.Mag);
					strcat(message,outstr);
						
					//output RAdeg,Dec formated data
					if(DebugLevel >=1)
					{
						strcat(message,"\nPos(RAdeg,Dec)=\n");
						sprintf( outstr, "%-6.2f %-6.2f\n",
								VF->SMUp.RA,VF->SMUp.Dec);
						strcat(message,outstr);
					}
					

					StatDlg->PostMess(message);
					StatDlg->ShowDialog("Info");
				}
				else//record mode on
				{
					GetRecordData(index);
				}
						
			}
			else if (vm_ViewMode == 1) //geo view mode
			{
				//get star RA,Dec
				cVSPos = SC.GetStar(index);
				
				//plot highlighted star in yellow
				VF->SelectPlotDC(0);//print to window
				VF->PlotStar(cVSPos,vm_StarStyle,6);
				VF->PlotStar(cVSPos,10,6);
				
				if(vm_RecordMode == 0)
				{

					//report found star info
					sprintf( outstr, "Star id=%d\n",
							SC.GetStarID(index) );
					message[0] = '\0';
					strcat(message,outstr);

					//VM.RAdeg2RAhm(cVSPos.RA,v_RAh,v_RAm);
					//sprintf( outstr, "RA=%d:%04.1f\nDec=%-6.2f\nMag=%-6.2f\n",
					//		(int)v_RAh,v_RAm,cVSPos.Dec,cVSPos.Mag);
					//strcat(message,outstr);

					strcat(message,"RA=");
					VM.RAStr(cVSPos.RA,outstr);
					strcat(message,outstr);strcat(message,"\n");
					strcat(message,"Dec=");
					VM.DecStr(cVSPos.Dec,outstr);
					strcat(message,outstr);strcat(message,"\n");

					sprintf( outstr, "Mag=%-6.2f\n",cVSPos.Mag);
					strcat(message,outstr);

					//get star AltAz
					VM.Celest2AltAz(vc_LocLat,vc_LocLong,
									vc_JulianDate,
									cVSPos.RA,cVSPos.Dec,
									aVSPos.Alt,aVSPos.Az);
					sprintf( outstr, "Alt=%-6.2f\nAz=%-6.2f\n",
							aVSPos.Alt,aVSPos.Az);
					strcat(message,outstr);

					//output RAdeg,Dec formated data
					if(DebugLevel>=1)
					{
						strcat(message,"\nPos(RAdeg,Dec)=\n");
						sprintf( outstr, "%-6.2f %-6.2f\n",
								VF->SMUp.RA,VF->SMUp.Dec);
						strcat(message,outstr);
					}

					StatDlg->PostMess(message);
					StatDlg->ShowDialog("Info");
				}
				else//record mode on
				{
					GetRecordData(index);
				}

			}
		}
		else
		if(index < 0)//planet found
		{
			int Object;
			double ObjRAdeg,ObjDec,ObjDia,ObjDist;
			double ObjAlt, ObjAz,ObjL, ObjB,ObjR;
			
			strcpy(message,"");

			if(DebugLevel >=5){
			sprintf( outstr, "Object=%d\n",index);
			strcpy(message,outstr);}

			Object = - (index + 10);
			switch(Object)
			{	case 0:{strcpy(outstr,"Sun\n");break;}
				case 1:{strcpy(outstr,"Mercury\n");break;}
				case 2:{strcpy(outstr,"Venus\n");break;}
				case 3:{strcpy(outstr,"Earth\n");break;}
				case 4:{strcpy(outstr,"Mars\n");break;}
				case 5:{strcpy(outstr,"Jupiter\n");break;}
				case 6:{strcpy(outstr,"Saturn\n");break;}
				case 7:{strcpy(outstr,"Uranus\n");break;}
				case 8:{strcpy(outstr,"Neptune\n");break;}
				case 9:{strcpy(outstr,"Pluto\n");break;}
				case 10:{strcpy(outstr,"Moon\n");break;}
			}

			strcat(message,outstr);
/*
			if(Object <=9)
			{
				VM.GetObjectData(Object,vc_JulianDate,vm_Equinox,
						   &ObjRAdeg,&ObjDec,&ObjDia);
			}
			else
			if(Object == 10)
			{
				VM.GetMoonData(vc_JulianDate,&ObjRAdeg,&ObjDec,&ObjDia);
			}
*/
			VM.GetPlanetInfo(Object,&ObjRAdeg,&ObjDec,
							&ObjDia, &ObjDist,
							&ObjAlt, &ObjAz,
							&ObjL, &ObjB,&ObjR);

			if(DebugLevel >= 6)
			{
				sprintf( outstr, "RA=%f\nDec=%f\n",
						ObjRAdeg,ObjDec);
				strcat(message,outstr);
			}

			//output RA in hms
			//VM.RAdeg2RAhms(ObjRAdeg,&v_RAh,&v_RAm,&v_RAs);
			//sprintf( outstr, "RA=%3.0f %2.0f %3.1f\n",
			//			v_RAh,v_RAm,v_RAs);
			//strcat(message,outstr);
			strcat(message,"RA=");
			VM.RAStr(ObjRAdeg,outstr);
			strcat(message,outstr);strcat(message,"\n");


			//output deg in dms
			strcat(message,"Dec=");
			VM.DecStr(ObjDec,outstr);
			strcat(message,outstr);strcat(message,"\n");

			//get star AltAz
			VM.Celest2AltAz(vc_LocLat,vc_LocLong,
							vc_JulianDate,
							ObjRAdeg,ObjDec,
							v_Alt,v_Az);
			sprintf( outstr, "Alt=%-6.2f\nAz=%-6.2f\n",
							v_Alt,v_Az);
			strcat(message,outstr);

			//output dist in dms
			sprintf( outstr, "\nDist=%6.3f AU\n",ObjDist);
			strcat(message,outstr);

			//output dist in dms
			sprintf( outstr, "Dia=%6.3f Deg\n",ObjDia);
			strcat(message,outstr);
		
			if(DebugLevel >= 1)
			{
				strcat(message,"\nHeliocentric:\n");
				sprintf( outstr, "L=%8.5f\nB=%8.5f\nR=%8.5f\n",
						ObjL,ObjB,ObjR);
				strcat(message,outstr);
			}

			//output report to dialog box
			StatDlg->PostMess(message);
			StatDlg->ShowDialog("Info");
		}
	}	
}




//////////////////////////////////////////////////
//BuildBSCatCond()
//  Builds condensed dat file for use by starcats.
//  Interface to StarCatalog::BuildBSCatCond()
//  Verifies file paths then calls SC.BuildBSCatCond()
//
///////////////////////////////////////////////////
void SCCmdWindow::BuildBSCatCond()
{

	int FileStat,ret;
	vNoticeDialog fsnote(this);

	//Post notice
	(void)fsnote.Notice("About to Build BS_catalog_cond.dat");

	////////////////////
	//Get input file
	////////////////////
	//FILE *pInFile;
	char fnameIn[50];
	//char instr[50];
	//char cstr[50];
	char outstr[40];
	//float buff;
	//fname = SCD.SettingsFileName; //"c:\\temp\\sky1.sky";
	//int FileStat; //1=openable, 0=not openable
	 static char* filterIn[] =     // define a filter list
	 {  
        "*.dat","*",0
      };
    static int filterIndexIn = 0;    // to track filter picked

	//get file name
	strcpy(fnameIn,SC.BSCatName);

	vFileSelect fselIn(this);     // instantiate
	//vNoticeDialog fsnote(this);

	int oansIn = fselIn.FileSelect("Open file",fnameIn,99,
								filterIn,filterIndexIn);
	
	if (oansIn && *fnameIn)
	{
		//save approved name
		strcpy(SC.BSCatName,fnameIn);
		FileStat = 1;//ok

	}
	else
	{
		FileStat = 0;//not ok, finish
	}


	////////////////////
	//Get output file
	////////////////////
	//FILE *pOutFile;
	char fnameOut[50];
	
	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	if(FileStat == 1)
	{
		//get file name
		strcpy(fnameOut,SC.BSCondCatName);

		vFileSelect fselOut(this);     // instantiate
		//vNoticeDialog fsnote(this);

		int oans = fselOut.FileSelectSave("Open file",fnameOut,99,
									filter,filterIndex);
		
		if (oans && *fnameOut)
		{
			//save approved file name
			strcpy(SC.BSCondCatName,fnameOut);
			FileStat = 1;
		}
		else
		{
			FileStat = 0;
		}
	}

	if(FileStat == 1)
	{
		ProgBar->StartProg("BS_catalog_cond.dat");
		ProgBar->SetTitle("Building...");

		ret = SC.BuildBSCatCond(ProgBar);

		ProgBar->FinishProg();

		sprintf( outstr, "Finished, ret =%d",ret);
		(void)fsnote.Notice(outstr);

	}


}
//////////////////////////////////////////////////
//BuildHipCatCond()
//
//
//
///////////////////////////////////////////////////
void SCCmdWindow::BuildHipCatCond()
{
	int FileStat;
	vNoticeDialog fsnote(this);
	int ret;
	char outstr[20];

	//Post notice
	(void)fsnote.Notice("About to Build hip_main_cond.dat\nWill Take Several Min");

	////////////////////
	//Get input file
	////////////////////
	//FILE *pInFile;
	char fnameIn[50];
	//char instr[50];
	//char cstr[50];
	//float buff;
	//fname = SCD.SettingsFileName; //"c:\\temp\\sky1.sky";
	//int FileStat; //1=openable, 0=not openable
	 static char* filterIn[] =     // define a filter list
	 {  
        "*.dat","*",0
      };
    static int filterIndexIn = 0;    // to track filter picked

	//get file name
	strcpy(fnameIn,SC.HipCatName);

	vFileSelect fselIn(this);     // instantiate
	//vNoticeDialog fsnote(this);

	int oansIn = fselIn.FileSelect("Open Input file",fnameIn,99,
								filterIn,filterIndexIn);
	
	if (oansIn && *fnameIn)
	{
		//save approved name
		strcpy(SC.HipCatName,fnameIn);
		FileStat = 1;//ok

	}
	else
	{
		FileStat = 0;//not ok, finish
	}


	////////////////////
	//Get output file
	////////////////////
	//FILE *pOutFile;
	char fnameOut[50];
	
	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	if(FileStat == 1)
	{
		//get file name
		strcpy(fnameOut,SC.HipCondCatName);

		vFileSelect fselOut(this);     // instantiate
		//vNoticeDialog fsnote(this);

		int oans = fselOut.FileSelectSave("Open Output file",fnameOut,99,
									filter,filterIndex);
		
		if (oans && *fnameOut)
		{
			//save approved file name
			strcpy(SC.HipCondCatName,fnameOut);
			FileStat = 1;
		}
		else
		{
			FileStat = 0;
		}
	}

	if(FileStat == 1)
	{
		ProgBar->StartProg("hip_main_cond.dat");
		ProgBar->SetTitle("Building...");

		ret = SC.BuildHipCatCond(ProgBar);

		ProgBar->FinishProg();

		sprintf( outstr, "Finished, ret =%d",ret);
		(void)fsnote.Notice(outstr);
	}


}
//////////////////////////////////////////////////
//BuildTycCatCond()
//Builds condensed dat file for use by starcats.
//
//
///////////////////////////////////////////////////
void SCCmdWindow::BuildTycCatCond()
{
	int ret = 0;
	char outstr[20];
	int FileStat;
	vNoticeDialog fsnote(this);

	//Post notice
	(void)fsnote.Notice(
		"About to Build tyc_main_cond.dat\nWill Take several 10 Min");

	////////////////////
	//Get input file
	////////////////////
	//FILE *pInFile;
	char fnameIn[50];
	//char instr[50];
	//char cstr[50];
	//float buff;
	//fname = SCD.SettingsFileName; //"c:\\temp\\sky1.sky";
	//int FileStat; //1=openable, 0=not openable
	 static char* filterIn[] =     // define a filter list
	 {  
        "*.dat","*",0
      };
    static int filterIndexIn = 0;    // to track filter picked

	//get file name
	strcpy(fnameIn,SC.TycCatName);

	vFileSelect fselIn(this);     // instantiate
	//vNoticeDialog fsnote(this);

	int oansIn = fselIn.FileSelect("Open file",fnameIn,99,
								filterIn,filterIndexIn);
	
	if (oansIn && *fnameIn)
	{
		//save approved name
		strcpy(SC.TycCatName,fnameIn);
		FileStat = 1;//ok

	}
	else
	{
		FileStat = 0;//not ok, finish
	}


	////////////////////
	//Get output file
	////////////////////
	//FILE *pOutFile;
	char fnameOut[50];
	
	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	if(FileStat == 1)
	{
		//get file name
		strcpy(fnameOut,SC.TycCondCatName);

		vFileSelect fselOut(this);     // instantiate
		//vNoticeDialog fsnote(this);

		int oans = fselOut.FileSelectSave("Open file",fnameOut,99,
									filter,filterIndex);
		
		if (oans && *fnameOut)
		{
			//save approved file name
			strcpy(SC.TycCondCatName,fnameOut);
			FileStat = 1;
		}
		else
		{
			FileStat = 0;
		}
	}

	if(FileStat == 1)
	{
		ProgBar->StartProg("tyc_main_cond.dat");
		ProgBar->SetTitle("Building...");

		ret = SC.BuildTycCatCond(ProgBar);

		ProgBar->FinishProg();

		sprintf( outstr, "Finished, ret =%d",ret);
		(void)fsnote.Notice(outstr);
	}


}
//////////////////////////////////////////////////
//LoadBSCat()
//  Load the BS Catalog.  If it is not found in the
//  expected place, a file select dialog is shown,
//  if the selected file exists, the expected location
//  (SC.BSCondCatName) is updated and the StarCatalog
//  SC.LoadBSCat function is called.
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadBSCat()
{
	FILE *pDataFile;		//data file pointer
	int FileStat; //1=openable, 0=not openable
	//LoadBSCat();
	char fname[100];
	int ret;

	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	vNoticeDialog fsnote(this); // make an instance

	FileStat = 0;
	strcpy(fname,SC.BSCondCatName);

	//try to open data
	pDataFile = fopen(fname,"r");

	//test if exists 
	if(pDataFile == NULL)
	{
		ret = -2;//error flag
		(void)fsnote.Notice("File Not Found!\nBrowse to Location or Cancel");
		vFileSelect fsel(this);     // instantiate

		int oans = fsel.FileSelect("Open file",fname,99,
									filter,filterIndex);
		
		if (oans && *fname)
		{
			//(void)fsnote.Notice(fname);
			pDataFile = fopen(fname,"r");

			//test if exists(athough fsel should check this)... 
			if(pDataFile == NULL)
			{
				ret = -3;//error flag
				(void)fsnote.Notice("No Such File!");
			}
			else
			{
				fclose(pDataFile);//close it
				strcpy(SC.BSCondCatName,fname);
				FileStat = 1;
			}

		}
		else
		{
			(void)fsnote.Notice("No file name input.");
		}
	}

	else//it exists so close it and set stat flag.
	{
		fclose(pDataFile);//close it
		FileStat = 1;
	}

	//if the file exist, open it...
	if(FileStat == 1)
	{	
		//ProgBar settup
		ProgBar->StartProg("BS_catalog_cond.dat");

		ret = SC.LoadBSCat(ProgBar);//and load the data...

		ProgBar->FinishProg();
		SetTitle("Bright Star");
	}

	return (ret);
}

//////////////////////////////////////////////////
//LoadHipCat()
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadHipCat()
{
	FILE *pDataFile;		//data file pointer
	int FileStat; //1=openable, 0=not openable
	//LoadBSCat();
	char fname[100];
	int ret;

	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	vNoticeDialog fsnote(this); // make an instance

	//(void)fsnote.Notice("NOTE: This will take about 30 sec\n(No Progress Bar Yet!)");

	FileStat = 0;
	strcpy(fname,SC.HipCondCatName);

	//try to open data
	pDataFile = fopen(fname,"r");

	//test if exists 
	if(pDataFile == NULL)
	{
		ret = -2;//error flag
		(void)fsnote.Notice("File Not Found!\nBrowse to Location or Cancel");

		vFileSelect fsel(this);     // instantiate

		int oans = fsel.FileSelect("Open file",fname,99,
									filter,filterIndex);
		
		if (oans && *fname)
		{
			//(void)fsnote.Notice(fname);
			pDataFile = fopen(fname,"r");

			//test if exists(athough fsel should check this)... 
			if(pDataFile == NULL)
			{
				ret = -3;//error flag
				(void)fsnote.Notice("No Such File!");
			}
			else
			{
				fclose(pDataFile);//close it
				strcpy(SC.HipCondCatName,fname);
				FileStat = 1;
			}

		}
		else
		{
			(void)fsnote.Notice("No file name input.");
		}
	}

	else//it exists so close it and set stat flag.
	{
		fclose(pDataFile);//close it
		FileStat = 1;
	}

	//if the file exist, open it...
	if(FileStat == 1)
	{	
		//ProgBar settup
		ProgBar->StartProg("hip_main_cond.dat");

		ret = SC.LoadHipCat(ProgBar);//and load the data...

		ProgBar->FinishProg();
		SetTitle("Hipparcos");
	}

	return (ret);
}




//////////////////////////////////////////////////
//LoadTycCat()
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadTycCat()
{
	FILE *pDataFile;		//data file pointer
	int FileStat; //1=openable, 0=not openable
	//LoadBSCat();
	char fname[100];
	int ret;

	 static char* filter[] =     // define a filter list
	 {  
        "*.dat",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked

	vNoticeDialog fsnote(this); // make an instance

	//(void)fsnote.Notice("NOTE: This will take about 5 min\nAt 133 Mhz\n(No Progress Bar Yet!)");

	FileStat = 0;
	strcpy(fname,SC.TycCondCatName);

	//try to open data
	pDataFile = fopen(fname,"r");

	//test if exists 
	if(pDataFile == NULL)
	{
		ret = -2;//error flag
		(void)fsnote.Notice("File Not Found!\nBrowse to Location or Cancel");

		vFileSelect fsel(this);     // instantiate

		int oans = fsel.FileSelect("Open file",fname,99,
									filter,filterIndex);
		
		if (oans && *fname)
		{
			//(void)fsnote.Notice(fname);
			pDataFile = fopen(fname,"r");

			//test if exists(athough fsel should check this)... 
			if(pDataFile == NULL)
			{
				ret = -3;//error flag
				(void)fsnote.Notice("No Such File!");
			}
			else
			{
				fclose(pDataFile);//close it
				strcpy(SC.TycCondCatName,fname);
				FileStat = 1;
			}

		}
		else
		{
			(void)fsnote.Notice("No file name input.");
		}
	}

	else//it exists so close it and set stat flag.
	{
		fclose(pDataFile);//close it
		FileStat = 1;
	}

	//if the file exist, open it...
	if(FileStat == 1)
	{	
		//ProgBar settup
		ProgBar->StartProg("hip_main_cond.dat");

		ret = SC.LoadTycCat(ProgBar);//and load the data...

		ProgBar->FinishProg();
	}

	SetTitle("Tycho");
	return (ret);
}


//////////////////////////////////////////////////
//GetRecordData(int index)
//
//
///////////////////////////////////////////////////
int SCCmdWindow::GetRecordData(int index)
{
	char outstr[500];
	int ret;

	if(index == 0)//redundant test
	{
		//gen help mess
		strcpy(outstr,"No Star Identified, point and Right Click to ID star");
	}
	else//get record for id'd star
	{
		ret = SC.ReadRecord(index);
		if(ret == -1)
		{
			strcpy(outstr,"Catalog File Not Found");
		}
		else 
		if(ret == 1)
		{
			if(vm_RecordMode == 1)
			strcpy(outstr,SC.PRecord);

			if(vm_RecordMode == 2)
			strcpy(outstr,SC.RawRecord);
		}
	}

	//output raw record to dlg and show it
	StatDlg->PostMess(outstr);
	StatDlg->ShowDialog("Info");


	return(0);
}


//////////////////////////////////////////////////
//LoadConLines()
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadConLines()
{
	vNoticeDialog note(this); // make an instance
	int ret1 = SC.LoadConLines();

	if(ret1 == -1)
		(void)note.Notice("ConLines.dat Not Found!");

	return (ret1);
}

//////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadConNames()
{
	//char outstr[20];
	vNoticeDialog note(this); // make an instance

	int ret = SC.LoadConNames();

	if(ret == -1)
	{
		(void)note.Notice("ConNames.dat Not Found!");
	}

	return (ret);
}

//////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////
int SCCmdWindow::LoadStarNames()
{
	//char outstr[20];
	vNoticeDialog note(this); // make an instance

	int ret = SC.LoadStarNames();

	if(ret == -1)
	{
		(void)note.Notice("StarNames.dat Not Found!");
	}

	return (ret);
}

//////////////////////////////////////////////////
//SetTimeNow()
//
//
///////////////////////////////////////////////////
void SCCmdWindow::SetTimeNow()
{
	int GMHour;
	int GMMin;
	int GMDay;
	int GMMon;
	int GMYear;
	int GMYDay;
	struct tm *newtime;
	long ltime;
	time( &ltime );


	/* Obtain coordinated universal time: */
	newtime = gmtime( &ltime );

	GMHour = newtime->tm_hour;
	GMMin = newtime->tm_min;
	//GMSec = newtime->tm_sec;
	GMDay = newtime->tm_mday;
	GMMon = newtime->tm_mon + 1;	//mon seems rel to 0
	GMYear = newtime->tm_year;
	GMYDay = newtime->tm_yday;

	//account for Y2K till 2050 GDI!:
	if(GMYear < 50) GMYear += 2000;
	else GMYear += 1900;

	vc_Hour = GMHour;
	vc_Minute = GMMin;
	vc_Day = GMDay;
	vc_Year = GMYear;
	vc_Month = GMMon;
}

//////////////////////////////////////////////////
//SetTimeDelta(double Days)
//
//
///////////////////////////////////////////////////
void SCCmdWindow::Setvm_TZLabel(double TZOffset)
{
	short int year,month,day;
	double hour;
	double z_JulianDate,z_Year,z_Month,z_Day,z_Hour,z_Minute;

	char buff[30];

	z_JulianDate = vc_JulianDate + (TZOffset / 24);
	VM.N.cal_date (z_JulianDate,
              &year, &month, &day,
              &hour);

	z_Year = (int)year;
	z_Month =(int)month;
	z_Day = (int)day;
	hour = hour;// + .0000001;
	z_Hour = (double)((int)hour);
	z_Minute = ((double)hour 
					- (double)z_Hour) * (double)60.0;


	strcpy(vm_LZT,vm_TZLabel);
	sprintf( buff, "%2d:%02d  ",(int)z_Hour,(int)z_Minute );
	strcat(vm_LZT,buff);
	sprintf( buff, "%02d/%02d/%04d",(int)z_Month,(int)z_Day,(int)z_Year );
	strcat(vm_LZT,buff);	

		
	//if(m_Minute < .001) m_Minute = 0;//to stop display of small exp number
	
}

//////////////////////////////////////////////////
//SetTimeDelta(double Days)
//
//
///////////////////////////////////////////////////
void SCCmdWindow::SetTimeDelta(double Days)
{
	short int year,month,day;
	double hour;

	vc_JulianDate += (Days);
	VM.N.cal_date (vc_JulianDate,
              &year, &month, &day,
              &hour);

	vc_Year = (int)year;
	vc_Month =(int)month;
	vc_Day = (int)day;
	hour = hour;// + .0000001;
	vc_Hour = (double)((int)hour);
	vc_Minute = ((double)hour 
					- (double)vc_Hour) * (double)60.0;

	//if(m_Minute < .001) m_Minute = 0;//to stop display of small exp number
	
}
//////////////////////////////////////////////////
//OnOpenSet()
//
//
///////////////////////////////////////////////////
void SCCmdWindow::OnOpenSet()
{
	FILE *pOutFile;
	char fname[80];
	char instr[80];
	char cstr[80];
	char bstr[80];
	float buff;
	int point;

	//fname = SCD.SettingsFileName; //"c:\\temp\\sky1.sky";
	//int FileStat; //1=openable, 0=not openable
	 static char* filter[] =     // define a filter list
	 {  
        "*.sky",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked


	//FileStat = 0;
	strcpy(fname,SC.SettingsFileName);

	vFileSelect fsel(this);     // instantiate
	vNoticeDialog fsnote(this);

	int oans = fsel.FileSelect("Open file",fname,99,
								filter,filterIndex);
	
	if (oans && *fname)
	{
		//(void)fsnote.Notice(fname);
		pOutFile = fopen(fname,"r");

		//test if exists(athough fsel should check this)... 
		if(pOutFile == NULL)
		{
			(void)fsnote.Notice("No Such File!");
		}
		else
		{
			//set file name param
			strcpy(fname,SC.SettingsFileName);

			//put read here:
			fgets(instr,20,pOutFile);//rip off header line

			fscanf(pOutFile,"%f",&vc_LocLat);
			fscanf(pOutFile,"%f",&vc_LocLong);
			fscanf(pOutFile,"%d",&vm_ViewMode);
			fscanf(pOutFile,"%d",&vm_ColorMode);
			fscanf(pOutFile,"%d",&vm_CSegMode);
			fscanf(pOutFile,"%d",&vm_LegendMode);
			fscanf(pOutFile,"%d",&vm_RAGridMode);
			fscanf(pOutFile,"%d",&vm_AltAzGridMode);
			fscanf(pOutFile,"%d",&vm_StarLabMode);

			fscanf(pOutFile,"%d",&vm_ViewCenterMode);
			fscanf(pOutFile,"%d",&vm_ConNameMode);
			fscanf(pOutFile,"%d",&vm_StarNameMode);
			//fscanf(pOutFile,"%d",&vm_AutoRecLoad);

			//main dialog edit boxes
			fscanf(pOutFile,"%f",&vc_RAh);
			fscanf(pOutFile,"%f",&vc_RAm);
			fscanf(pOutFile,"%f",&vc_Dec);
			fscanf(pOutFile,"%f",&vc_Rot);
			fscanf(pOutFile,"%f",&vc_VAng);
			fscanf(pOutFile,"%f",&vc_Mag);

			fscanf(pOutFile,"%d",&vc_Day);
			fscanf(pOutFile,"%d",&vc_Month);
			fscanf(pOutFile,"%d\n",&vc_Year);

			fscanf(pOutFile,"%f",&buff);
			vc_Hour = (double)buff;

			fscanf(pOutFile,"%f",&buff);
			vc_Alt = (double)buff;

			fscanf(pOutFile,"%f",&buff);
			vc_Az = (double)buff;

			fscanf(pOutFile,"%f",&buff);
			vc_Minute = (double)buff;

			//read to end of that line
			fgets(cstr,49,pOutFile);

			//NOTE: getfile names
			//cuases errors!, maybe unalighned?
			//error because SCtring read in have \n
			//on the end of them!
			//fixed by stripping off the \n
			//NOTE: this may not work in linux!!!

			//this block adds garbag on end ?:
			//fgets(cstr,70,pOutFile);
			//strncpy(bstr,cstr,strlen(cstr)-2);
			//strcpy(SC.BSCondCatName,bstr);

			//this block works for windows:
			//  but may not for linux
			//fgets(cstr,70,pOutFile);
			//cstr[strlen(cstr)-1] = '\0';
			//strcpy(SC.BSCondCatName,cstr);

			//This block idexes into file name for
			//  first '.', then adds null char to
			//  end. should work in linux unless the
			//  dir name has a '.' in it...
			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.BSCondCatName,cstr);

			
			fgets(cstr,70,pOutFile); 
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.BSCatName,cstr);
		

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.HipCondCatName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.HipCatName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.TycCondCatName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.TycCatName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.ConLinesFileName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.ConNamesFileName,cstr);
			

			fgets(cstr,70,pOutFile);
			point = strcspn(cstr,".");
			cstr[point+4] = '\0';
			strcpy(SC.StarNamesFileName,cstr);
			

			
			fclose(pOutFile);
			
		}

	}
	else
	{
		(void)fsnote.Notice("No file name input.");
	}

	UpDateToolBarS(0);

}
//////////////////////////////////////////////////
//
//
//
///////////////////////////////////////////////////
void SCCmdWindow::OnSaveSet()
{
	FILE *pOutFile;
	char fname[50];
	//fname = SCD.SettingsFileName; //"c:\\temp\\sky1.sky";
	//int FileStat; //1=openable, 0=not openable
	 static char* filter[] =     // define a filter list
	 {  
        "*.sky",
		"*",// .txt files
        0
      };
    static int filterIndex = 0;    // to track filter picked


	//FileStat = 0;
	strcpy(fname,SC.SettingsFileName);

	vFileSelect fsel(this);     // instantiate
	vNoticeDialog fsnote(this);

	int oans = fsel.FileSelectSave("Open file",fname,99,
								filter,filterIndex);
	
	if (oans && *fname)
	{
		//(void)fsnote.Notice(fname);
		pOutFile = fopen(fname,"w");

		//test if exists(athough fsel should check this)... 
		if(pOutFile == NULL)
		{
			(void)fsnote.Notice("No Such File!");
		}
		else
		{
			//set file name param
			strcpy(fname,SC.SettingsFileName);

			fprintf(pOutFile,"StarViewSettings\n"); 

			//view details
			fprintf(pOutFile,"%f\n",vc_LocLat);
			fprintf(pOutFile,"%f\n",vc_LocLong);
			fprintf(pOutFile,"%d\n",vm_ViewMode);
			fprintf(pOutFile,"%d\n",vm_ColorMode);
			fprintf(pOutFile,"%d\n",vm_CSegMode);
			fprintf(pOutFile,"%d\n",vm_LegendMode);
			fprintf(pOutFile,"%d\n",vm_RAGridMode);
			fprintf(pOutFile,"%d\n",vm_AltAzGridMode);
			fprintf(pOutFile,"%d\n",vm_StarLabMode);

			
			fprintf(pOutFile,"%d\n",vm_ViewCenterMode);
			fprintf(pOutFile,"%d\n",vm_ConNameMode);
			fprintf(pOutFile,"%d\n",vm_StarNameMode);

			

			//main dialog edit boxes
			fprintf(pOutFile,"%f\n",vc_RAh);
			fprintf(pOutFile,"%f\n",vc_RAm);
			fprintf(pOutFile,"%f\n",vc_Dec);
			fprintf(pOutFile,"%f\n",vc_Rot);
			fprintf(pOutFile,"%f\n",vc_VAng);
			fprintf(pOutFile,"%f\n",vc_Mag);

			fprintf(pOutFile,"%d\n",vc_Day);
			fprintf(pOutFile,"%d\n",vc_Month);
			fprintf(pOutFile,"%d\n",vc_Year);


			fprintf(pOutFile,"%f\n",vc_Hour);
			fprintf(pOutFile,"%f\n",vc_Alt);
			fprintf(pOutFile,"%f\n",vc_Az);
			fprintf(pOutFile,"%f\n",vc_Minute);

			//file locations
			fprintf(pOutFile,SC.BSCondCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.BSCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.HipCondCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.HipCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.TycCondCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.TycCatName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.ConLinesFileName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.ConNamesFileName);
			fprintf(pOutFile,"\n");
			fprintf(pOutFile,SC.StarNamesFileName);
			fprintf(pOutFile,"\n");

			fprintf(pOutFile,SC.SettingsFileName);
			fprintf(pOutFile,"\n");
			
			fclose(pOutFile);
			
		}

	}
	else
	{
		(void)fsnote.Notice("No file name input.");
	}

	
}

/////////////////////////////////////////
//CondRePlot()
//  Conditional replot. Replots if conditions 
//  are such thatit won't take forever.
// Otherwise gives press plot status message
/////////////////////////////////////////
void SCCmdWindow::CondRePlot()
{
	if(SC.CatalogMode == 1
		|| vc_Mag <=6)
	{
		PlotView();
	}
	else
	{
		SetString(t_StatMessage, "Press Plot to RePlot");
	}
}
/////////////////////////////////////////
//OnTimer
//  Timer event handler
/////////////////////////////////////////
void SCCmdWindow::OnTimer()
{
	char outstr[20];

	_auxTimer->TimerStop();
	theApp->CheckEvents();
	if(vt_TimeLapseMode == 1)
	{
		SetTimeDelta(vt_dJulian);
		UpDateToolBarS(0);
		theApp->CheckEvents();
		PlotView();
		theApp->CheckEvents();	// checking here prevents exception error
								//when the window bar shutdown check box
								//is checked while in time lapse!
								//...well... not all of the time!!!!!
		
		//time lapse coundt
		TimeLapseCnt += 1;

		//output count to stat bar
		sprintf( outstr, "Time Lapse %d ",TimeLapseCnt );
		SetString(t_StatPosition, outstr);
		
		if(vt_TimeLapseMode == 1)
		{
			_auxTimer->TimerSet(vt_Intms);
		}
	}

	theApp->CheckEvents();
}

/////////////////////////////////////////
//StopTimer()
/////////////////////////////////////////
void SCCmdWindow::StopTimer()
{
	_auxTimer->TimerStop();
	vt_TimeLapseMode = 0;
}
////////////////////////////////////////////////////////
//GotoObject(int Object)
//  Gets an objects position(FigurePlanInfo must be run
//  first), and sets current view direction to it.
////////////////////////////////////////////////////////
void SCCmdWindow::GotoObject(int Object)
{
	STARDATA ObjSTAR;
	double ObjRAdeg,ObjDec,ObjDia,ObjDist;
	double ObjAlt, ObjAz,ObjL, ObjB,ObjR;

	VM.GetPlanetInfo(Object,&ObjRAdeg,
					&ObjDec,&ObjDia,&ObjDist,
					&ObjAlt, &ObjAz,
					&ObjL, &ObjB,&ObjR);

	if(vm_ViewMode == 0)	//sky view mode
	{
		//set box center to view center
		vc_Dec = ObjDec; 
		float RA = ObjRAdeg;
		if(RA < 0) RA = RA + 360;
		vc_RAh = (float)((int)(RA/15));
		vc_RAm =(RA - vc_RAh * 15) * 4;
	}
	else if (vm_ViewMode == 1) //geo view mode
	{
		//set box center to view center
		ALTAZVEC NPSga;	//
		VM.Celest2AltAz(vc_LocLat,vc_LocLong,
						vc_JulianDate,
						ObjRAdeg,ObjDec,
						NPSga.Alt,NPSga.Az);

		vc_Alt = NPSga.Alt;
		vc_Az = NPSga.Az;
	}
}

////////////////////////////////////////////////////////
//SetAutoBlob()
////////////////////////////////////////////////////////
void SCCmdWindow::SetAutoBlob()
{
	float ViewAng = 2 * VF->VCHAng;
	//set all cehcks off:

	if(SC.NumStar < 20000)//if small catalog, don't bother
	{
		vm_StarStyle = 2;

	}
	else
	{
		if(ViewAng > 45)
		{
			vm_StarStyle = 2;

		}
		else
		{
			if(ViewAng > 20)
			{
				if(vc_Mag <=7)
				{
					vm_StarStyle = 2;

				}
				else //if(vc_Mag <=8)
				{
					vm_StarStyle = 3;

				}
			}
			else
			if(ViewAng > 10)
			{
				if(vc_Mag <=7)
				{
					vm_StarStyle = 2;
				}
				else if(vc_Mag <=8)
				{
					vm_StarStyle = 3;
				}
				else
				{
					vm_StarStyle = 4;;
				}
			}
			else
			if(ViewAng > 5)
			{
				if(vc_Mag <=7)
				{
					vm_StarStyle = 2;
				}
				else if(vc_Mag <=8)
				{
					vm_StarStyle = 3;
				}
				else //if(vc_Mag <=9)
				{
					vm_StarStyle = 4;
				}
			
			}
			else
			{
				if(vc_Mag <=7)
				{
					vm_StarStyle = 2;
				}
				else if(vc_Mag <=8)
				{
					vm_StarStyle = 3;
				}
				else if(vc_Mag <=9)
				{
					vm_StarStyle = 4;
				}
			
				else
				{
					vm_StarStyle = 5;
				}
			}	
		}
	}
}

////////////////////////////////////////////////////////
//PrintSky()
//	Prints view out to printer. Uses PlotView(1) to plot 
//  sky to printer device context, which is part of
//  VF, the canvas window.
////////////////////////////////////////////////////////
void SCCmdWindow::PrintSky()
{
	int PSizeX,PSizeY;
	int SizeX = 400;
	int SizeY = 300;
	int OffsetX = 50;
	int OffsetY = 100;
	
	char outstr[40];

	if(VF->SetupToPrint() != 1)
	{
		return;
		//VF->EndPrint();
	}

	//Save Old window size
	int Old_FXMax = VF->FXMax;
	int Old_FYMax = VF->FYMax;

	//figure aspect ratio and SizeY
	float AspectR = (float)Old_FYMax / (float)Old_FXMax;
	SizeY = AspectR * SizeX;

	//check for SizY too big...
	if(SizeY > PSizeY - OffsetY  - 100)
		SizeY = PSizeY - OffsetY  - 100;

	//get paper size
	PSizeX = VF->pdc.GetPhysWidth();
	PSizeY = VF->pdc.GetPhysHeight();

	//center on paper
	OffsetX = (PSizeX - SizeX) / 2;

	//set color mode to black on white and save old
	int Old_vm_ColorMode = vm_ColorMode;
	vm_ColorMode = 3;

	//Set plot size.
	VF->SetViewSizeParam(SizeX, SizeY);

	//VF->SelectPlotDC(2);
	VF->pdc.SetTranslate(OffsetX,OffsetY);// Add 1/2" (36 * 1/72") margins
	PrintPlotView(0);

	//Block Out Border
	vColor color;
	color.Set(255,255,255);//white
	VF->pGenPen.SetColor(color);
	VF->pGenBrush.SetColor(color);
	VF->OutputDC->SetPen(VF->pGenPen);
	VF->OutputDC->SetBrush(VF->pGenBrush);

	VF->OutputDC->SetTranslate(0,0);
	VF->OutputDC->DrawRectangle(0,0,PSizeX,OffsetY);
	VF->OutputDC->DrawRectangle(0,0,OffsetX,PSizeY);
	VF->OutputDC->DrawRectangle(OffsetX+SizeX,0,
								PSizeX-OffsetX,PSizeY);
	VF->OutputDC->DrawRectangle(0,OffsetY+SizeY,PSizeX,PSizeY);

	//Draw Outline
	color.Set(0,0,0);//black
	VF->pGenPen.SetColor(color);
	VF->pGenBrush.SetColor(color);
	VF->OutputDC->SetPen(VF->pGenPen);
	VF->OutputDC->SetBrush(VF->pGenBrush);

	VF->OutputDC->SetTranslate(OffsetX,OffsetY);
	VF->OutputDC->DrawLine(0,0, SizeX,0);
	VF->OutputDC->DrawLine(SizeX,0, SizeX,SizeY);
	VF->OutputDC->DrawLine(SizeX,SizeY, 0,SizeY);
	VF->OutputDC->DrawLine(0,SizeY, 0,0);

	//print header and reports
	VF->OutputDC->SetTranslate(0,0);
	vFont Font1(vfSansSerif,10,vfNormal,vfNormal,0,0);
	VF->OutputDC->SetFont(Font1);

	//header
	char text[100];
	//strcpy(text,"StarCat:");
	//VF->OutputDC->DrawText(OffsetX , OffsetY-2, text);

	//footer
	float RAdeg = vc_RAh * (float)15.0 + vc_RAm * (float).25;
	strcpy(PrintReport,"View Center:RA=");
	VM.RAStr(cViewPoint.RA,outstr);
	strcat(PrintReport,outstr);
	strcat(PrintReport," Dec=");
	VM.DecStr(cViewPoint.Dec,outstr);
	strcat(PrintReport,outstr);
	
	if(vm_ViewMode == 1)//if geo view mode
	{
		sprintf( outstr, " Alt=%6.2f Az=%6.2f"
			,vc_Alt,vc_Az );
		strcat(PrintReport,outstr);
	}

	sprintf( outstr, " View Angle=%5.2f",vc_VAng );
	strcat(PrintReport,outstr);

	//print footer
	VF->OutputDC->DrawText(OffsetX , 
							OffsetY+SizeY + 15, PrintReport);


	//end the print process
	VF->EndPrint();

	//restore old color mode and size
	vm_ColorMode = Old_vm_ColorMode;
	VF->SetViewSizeParam(Old_FXMax, Old_FYMax);
}

