//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//	SCcnv.h:	Header for SCCanvasPane class
//=======================================================================

#ifndef SCCNV_H
#define SCCNV_H

//#include "SCcmdw.h"

#include <v/vcanvas.h>
#include <v/vmemdc.h> 
#include <v/vapp.h>		//needed to use theApp->ScreenWidth();...

#include <v/vprintdc.h>
#include <v/vprinter.h>

//#########################
#include "VMath.h"
//#include <v/vcmdwin.h>	// So we can use vCmdWindow
//#include "SCcmdw.h"
//#########################

	class vBaseWindow;

    class SCCanvasPane : public vCanvasPane
      {
      public:		//---------------------------------------- public

	//###############################3
	//jac SC adds
	CVMath VM;
	bool drawn;//(crj,  for Lesstiff start check

	//beg frame vars
	float VCRot,VCHAng;				//view center cords and angle of view
	STARDATA ViewCen;				//veiw center, sky cords
	int SizeX,SizeY;
	int	FXMax,FYMax;				//view frame size
	int FXCen,FYCen;				//frame center
	int LastX,LastY;				//last plotted star position

	STARDATA NewViewCen;			//new view center
	float SymRefLev;				//symbl ref level
	int ColorMode;	//0=norm,1=whtonBlk,2=redonblk,4=black on white


	//mouse action params
	int MDownx,MDowny;				//Left Mouse down position
	int MRUpx,MRUpy;				//Left Mouse Up position
	int MRDownx,MRDowny;			//Right Mouse down position
	int MUpx,MUpy;					//Right Mouse Up position
	int MFlagD,MFlagU;				//Mouse flag 8=ctr, 4 =shft
	int MStatus;					//0=none, 1=down
	int MRBStatus;					//0=none, 1=drawn
	STARDATA	SMDown,SMUp,SMMid;	//left sphere Mouse up and down
	STARDATA	SMRDown,SMRUp,SMRMid;	//Right Mouse sphere Mouse up and down
	int LastRLx;					//Last Rubber line position
	int LastRLy;					// "
	int LastRLhw;					// "
	int VFMessActType;				//Action type, mess to cmdwin
									//1=center, 2=zoom, 3=id closest star
	//mouse motion testing
	int MoveCounter;
	int Mx,My;
	STARDATA SMPos;

	//general stuff
	vPen pGenPen;
	vBrush pGenBrush;

	//drawing canvas
	vMemoryDC* memDC;
	vDC* OutputDC;

	//printer stuff
	vPrintDC pdc;               // create a vPrintDC object
    vPrinter printer;           // and a printer to set attributes





	//star cat functions
	void Test();
	void SetViewParam(float RA, float Dec, float Rot,
					float Ang, int ColorM);
	void SetViewSizeParam(int x, int y);
	void ClearView();
	void PutStar(int x, int y,int Style,int Color, float Mag);
	void PlotSeg(STARDATA Star1,STARDATA Star2);
	bool PlotStar(STARDATA Star,int Style,int Color);
	int FrameRectPos(STARDATA SPos, int &x, int &y);
	STARDATA FramePos(int xin, int yin);
	RECTVEC GetPSPosFC(STARDATA Star);
	void PlotGrid();
	void PlotHorizon(STARDATA cZenith);
	void PlotAltAzGrid(STARDATA cZenith);
	void PlotHorizonCompLabels(STARDATA cZenith);
	void SetGenPen(int penID);
	void SetGenPenRGB(int R, int G, int B);
	void PlotViewCenter(float Rad);
	void PlotLegend(int Style, int MaxMag);
	void PlotTextXY(char* text, int x, int y ,
					int xos,int yos,
					int Style,int Color);
	void PlotTextS(char* text, STARDATA S1,
				    int xos,int yos,
					int Style,int Color);
	bool PlotObject(STARDATA Star,
					int Object,int Color,
					float Dia,int Label,
					int *xplot, int *yplot);

	void SelectPlotDC(int SelDC);
	void UpdateCanvasDC();

	int SetupToPrint();
	void EndPrint();

	

	//
	//SCCmdWindow* Pcmdw;
	vWindow* pWin;		// our parent



	//################################

	//appgen builts:
	SCCanvasPane(vBaseWindow* bw);
	virtual ~SCCanvasPane();

	// Scrolling
	virtual void HPage(int shown, int top);
	virtual void VPage(int shown, int top);

	virtual void HScroll(int step);
	virtual void VScroll(int step);

	// Events
	virtual void MouseDown(int x, int y, int button);
	virtual void MouseUp(int x, int y, int button);
	virtual void MouseMove(int x, int y, int button);

	virtual void Redraw(int x, int y, int width, int height);
	virtual void Resize(int newW, int newH);

	//jc add manually
	virtual void MouseMotion(int x, int y);

	

      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private
      };
#endif
