//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//=======================================================================
//@V@:Note: This file generated by vgen V1.07 (00:31:08 21 Nov 1999).
//	SCmdlg.cpp:	Source for SCModalDialog class
//=======================================================================

#include "SCmdlg.h"
#include "SCcmdw.h"
#include <v/vnotice.h>

//@V@:BeginIDs
    enum {
    lblMainMsg = 1000,
	t_m1,t_m2,t_m3,
	t_LocLat,t_LatS,
	t_LocLong,t_LonS,
    btnTestMDlg		// add your id's here
  };
//@V@:EndIds

//@V@:BeginDialogCmd DefaultCmds
    static DialogCmd DefaultCmds[] =
      {
	{C_Label, t_m3, 0,"Location:",NoList,CA_None,isSens,NoFrame, 0, 0},

	{C_Label, t_m1,0,"Lat:",NoList,CA_None,isSens,
	         NoFrame,0,t_m3, 15,0},
	{C_TextIn, t_LocLat, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m1,t_m3, 8,0},
	{C_Label, t_LatS,0,"+N -S",NoList,CA_None,isSens,
	         NoFrame,t_LocLat,t_m3, 20,0},

	{C_Label, t_m2,0,"Long:",NoList,CA_None,isSens,
	         NoFrame,0,t_m1, 15,0},
	{C_TextIn, t_LocLong, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m2, t_m1, 8,0},
	{C_Label, t_LonS,0,"+E -W",NoList,CA_None,isSens,
	         NoFrame,t_LocLong,t_m1, 20,0},

	

	{C_Button, M_Cancel, 0, " Cancel ",NoList,CA_None,
	    isSens,NoFrame,0, t_m2},
	{C_Button, M_OK, 0, " OK ", NoList, CA_DefaultButton,
	    isSens, NoFrame, M_Cancel, t_m2},

	//{C_Button, btnTestMDlg, 0, " Test ", NoList, CA_None,
	 //   isSens, NoFrame, M_OK, t_m2},

	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
    };
//@V@:EndDialogCmd


//======================>>> SCModalDialog::SCModalDialog <<<==================
  SCModalDialog::SCModalDialog(vBaseWindow* bw, char* title) :
    vModalDialog(bw, title)
  {
    UserDebug(Constructor,"SCModalDialog::SCModalDialog()\n")
    _myCmdWin = (SCCmdWindow*) bw;
    AddDialogCmds(DefaultCmds);		// add the predefined commands
  }

//===================>>> SCModalDialog::~SCModalDialog <<<====================
  SCModalDialog::~SCModalDialog()
  {
    UserDebug(Destructor,"SCModalDialog::~SCModalDialog() destructor\n")
  }

//====================>>> SCModalDialog::SCAction <<<====================
  int SCModalDialog::SCAction(char* msg)
  {
    ItemVal ans,rval;

    ans = ShowModalDialog(msg,rval);
    if (ans == M_Cancel)
	return 0;

    // *** Add code to process dialog values here
	char outstr[20];
	GetTextIn(t_LocLat , outstr,20);
	sscanf(outstr,"%f",&dd_LocLat);

	GetTextIn(t_LocLong , outstr,20);
	sscanf(outstr,"%f",&dd_LocLong);
	
	//note-the M_OK didn't seem to pass ok?
    //return ans == M_OK;
	return 1;
  }

//====================>>> SCModalDialog::DialogCommand <<<====================
  void SCModalDialog::DialogCommand(ItemVal id, ItemVal retval, CmdType ctype)
  {
    UserDebug2(CmdEvents,"SCModalDialog::DialogCommand(id:%d, val:%d)\n",id, retval)

    switch (id)		// We will do some things depending on value
      {
	//@V@:Case: btnTestMDlg
	case btnTestMDlg:
	  {
	    vNoticeDialog note(this);
	    note.Notice("Test Dialog");
	    break;
	  }	//@V@:EndCase
      }

    vModalDialog::DialogCommand(id,retval,ctype);
  }

////////////////////////////////////////
//DialogDisplayed()
// added manually to set dlg on display
//
////////////////////////////////////////
  void SCModalDialog::DialogDisplayed()
  {
	  char outstr[20];

	  sprintf( outstr, "%7.4f",dd_LocLat);
	  SetString(t_LocLat,outstr);
	  sprintf( outstr, "%7.4f",dd_LocLong);
	  SetString(t_LocLong,outstr);
  }

