//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//=======================================================================
//@V@:Note: This file generated by vgen V1.07 (00:31:08 21 Nov 1999).
//	SCmdlg.cpp:	Source for SCModalDialog class
//=======================================================================

#include "TimeLdlg.h"
#include "SCcmdw.h"

#include <v/vnotice.h>

//@V@:BeginIDs
    enum {
    lblMainMsg = 1000,
	t_m1,t_m2,t_m3,t_m4,t_m5,t_m6,t_mm1,
	t_Day,
	t_Hour,
	t_Min,
	t_Delay,
	t_Int,
    btnTestMDlg		// add your id's here
  };
//@V@:EndIds

//@V@:BeginDialogCmd DefaultCmds
static DialogCmd DefaultCmds[] =
{
	{C_Label, t_m3, 0,"Time Step::",NoList,CA_None,isSens,NoFrame, 0, 0},
	{C_Label, t_m1,0,"Days:",NoList,CA_None,isSens,
	         NoFrame,0,t_m3, 15,0},
	{C_TextIn, t_Day, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m1,t_m3, 8,0},
	{C_Label, t_m2,0,"Hours",NoList,CA_None,isSens,
	         NoFrame,0,t_m1, 15,0},
	{C_TextIn, t_Hour, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m2, t_m1, 8,0},	
	{C_Label, t_m4,0,"Min",NoList,CA_None,isSens,
	         NoFrame,0,t_m2, 15,0},
	{C_TextIn, t_Min, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m4, t_m2, 8,0},	
	{C_Label, t_mm1, 0,"Interval",NoList,CA_None,isSens,NoFrame, 0, t_m4},

	{C_Label, t_m5,0,"Sec",NoList,CA_None,isSens,
	         NoFrame,0,t_mm1, 15,0},
	{C_TextIn, t_Int, 0, "00", NoList,CA_Small,isSens,
	         NoFrame, t_m5, t_mm1, 8,0},	
	{C_Button, M_Cancel, 0, " Cancel ",NoList,CA_None,
	    isSens,NoFrame,0, t_m5},
	{C_Button, M_OK, 0, " Go ", NoList, CA_DefaultButton,
	    isSens, NoFrame, M_Cancel, t_m5},
	//{C_Button, btnTestMDlg, 0, " Test ", NoList, CA_None,
	 //   isSens, NoFrame, M_OK, t_m2},

	{C_EndOfList,0,0,0,0,CA_None,0,0,0}
};
//@V@:EndDialogCmd


//======================>>> SCModalDialog::SCModalDialog <<<==================
  CTimeLdlg::CTimeLdlg(vBaseWindow* bw, char* title) :
    vModalDialog(bw, title)
{
    UserDebug(Constructor,"CTimeLdlg::CTimeLdlg()\n")
    _myCmdWin = (SCCmdWindow*) bw;
    AddDialogCmds(DefaultCmds);		// add the predefined commands
  
	dd_Day = 0;
	dd_Hour = 0;
	dd_Min = 10;
	dd_Int = 0;
	
}

//===================>>> SCModalDialog::~SCModalDialog <<<====================
  CTimeLdlg::~CTimeLdlg()
  {
    UserDebug(Destructor,"CTimeLdlg::~CTimeLdlg() destructor\n")
  }

//====================>>> SCModalDialog::SCAction <<<====================
  int CTimeLdlg::SCAction(char* msg)
  {
    ItemVal ans,rval;

    ans = ShowModalDialog(msg,rval);
    if (ans == M_Cancel)
	return 0;

    // *** Add code to process dialog values here
	char outstr[20];
	GetTextIn(t_Day , outstr,20);
	sscanf(outstr,"%f",&dd_Day);

	GetTextIn(t_Hour , outstr,20);
	sscanf(outstr,"%f",&dd_Hour);

	GetTextIn(t_Min , outstr,20);
	sscanf(outstr,"%f",&dd_Min);

	GetTextIn(t_Int , outstr,20);
	sscanf(outstr,"%f",&dd_Int);
	
	//note-the M_OK didn't seem to pass ok?
    //return ans == M_OK;
	return 1;
  }

//====================>>> SCModalDialog::DialogCommand <<<====================
  void CTimeLdlg::DialogCommand(ItemVal id, ItemVal retval, CmdType ctype)
  {
    UserDebug2(CmdEvents,"CTimeLdlg::DialogCommand(id:%d, val:%d)\n",id, retval)

    switch (id)		// We will do some things depending on value
      {
	//@V@:Case: btnTestMDlg
	case btnTestMDlg:
	  {
	    vNoticeDialog note(this);
	    note.Notice("Test Dialog");
	    break;
	  }	//@V@:EndCase
      }

    vModalDialog::DialogCommand(id,retval,ctype);
  }

////////////////////////////////////////
//DialogDisplayed()
// added manually to set dlg on display
//
////////////////////////////////////////
  void CTimeLdlg::DialogDisplayed()
  {
	  char outstr[20];

	  //set title bar text
	  SetDialogTitle("TimeLapse");

	  sprintf( outstr, "%3.0f",dd_Day);
	  SetString(t_Day,outstr);
	  sprintf( outstr, "%3.0f",dd_Hour);
	  SetString(t_Hour,outstr);
	  sprintf( outstr, "%3.0f",dd_Min);
	  SetString(t_Min,outstr);

	  sprintf( outstr, "%3.0f",dd_Int);
	  SetString(t_Int,outstr);
  }

